from mower.utils import config
from mower.utils.graph import SceneGraphSolver
from mower.utils.scene import Scene


class Guess(SceneGraphSolver):
    solver_name = "竞猜"

    def run(self):
        self.full = False
        super().run()
        config.conf.task["mower.solvers.long_task.LongTask"] = not self.full
        return self.full

    def transition(self):
        if (scene := self.scene()) == Scene.TERMINAL_MAIN:
            self.terminal_entry("guess/channel")
        elif scene == Scene.GUESS_MAIN:
            if self.find("guess/max"):
                self.full = True
                return True
            self.tap((1720, 920))
        elif scene == Scene.GUESS_CHOOSE:
            if self.find("guess/start_match"):
                self.ctap("guess/start_match", 3)
                return
            self.tap((860, 860))
        elif scene == Scene.GUESS_FIGHT:
            if self.find("guess/out"):
                self.ctap("guess/exit", 3)
                return
            self.tap((200, 960))
        elif scene == Scene.GUESS_SETTLEMENT:
            self.ctap("guess/continue", 3)
        else:
            self.scene_graph_step(Scene.TERMINAL_MAIN)
