from mower.solvers.shop import CreditShop

from .daily import DailySolver
from .get_clue_count import GetClueCountSolver
from .give_away import GiveAwaySolver
from .message_board import MessageBoard
from .party_time import PartyTimeSolver
from .place import PlaceSolver
from .receive import ReceiveSolver


class ClueManager:
    solver_name = "线索交流"

    def run(self):
        MessageBoard().run()
        DailySolver().run()
        ReceiveSolver().run()
        PlaceSolver().run()
        clue_count = GetClueCountSolver().run()
        GiveAwaySolver().run(clue_count)
        PartyTimeSolver().run()
        CreditShop().run()
        return True
