from datetime import timedelta

from mower.utils.recognize import Scene
from mower.utils.solver import BaseSolver


class MissionSolver(BaseSolver):
    solver_name = "每日/每周任务"
    solver_max_duration = timedelta(minutes=2)

    def run(self) -> None:
        self.daily = False
        return super().run()

    def transition(self):
        if (scene := self.scene()) == Scene.MISSION_DAILY:
            if self.daily:
                self.tap("mission_weekly")
                return
            if pos := self.find("mission_collect"):
                self.tap(pos)
                return
            if self.animation(((0, 0), (560, 1080))):
                return
            self.daily = True
            self.solver_update_before_transition = False
        elif scene == Scene.MISSION_WEEKLY:
            if not self.daily:
                self.tap("mission_daily")
                return
            if pos := self.find("mission_collect"):
                self.tap(pos)
                return
            if self.animation(((0, 0), (560, 1080))):
                return
            return True
        else:
            self.scene_graph_step(Scene.MISSION_DAILY)
