from mower.utils import config
from mower.utils import typealias as tp
from mower.utils.image import cropimg
from mower.utils.rapidocr import ocr_rec


def index_entry(res: tp.Res, text: str) -> tp.Scope | None:
    score, scope = config.recog.match(res)
    if score < 0.8:
        return None
    img = cropimg(config.recog.gray, scope)
    h, w = img.shape
    lh = h // 2
    line1 = cropimg(img, ((0, 0), (w, lh)))
    line2 = cropimg(img, ((0, lh), (w, h)))
    if text != ocr_rec(line1) + ocr_rec(line2):
        return None
    return scope
