from mower.utils.scene import Scene
from mower.utils.solver import BaseSolver

from .utils import DG, edge

# 终端

terminal_button = {
    501: "main",
    502: "score",
    503: "collection",
    504: "regular",
    505: "longterm",
    506: "periodic",
}


def terminal_transition_factory(t):
    def terminal_transition(solver: BaseSolver):
        solver.tap_terminal_button(terminal_button[t])

    return terminal_transition


for s in range(501, 507):
    for t in range(501, 507):
        if t == s:
            continue
        DG.add_edge(s, t, transition=terminal_transition_factory(t))


@edge(Scene.TERMINAL_PREVIOUS, Scene.TERMINAL_SCORE)
def previous_back(solver: BaseSolver):
    solver.back()
