import { __unplugin_components_14, __unplugin_components_16, __unplugin_components_7 as __unplugin_components_7$1, __unplugin_components_17 } from "./SlickOperatorSelect.js";
import { __unplugin_components_0 as __unplugin_components_0$1 } from "./HelpText.js";
import { createTheme, derived, c, cB, fadeInScaleUpTransition, defineComponent, h, getFirstSlotVNodeWithTypedProps, Transition, withDirectives, clickoutside, useConfig, useFormItem, ref, toRef, useMergedState, useTheme, computed, useThemeClass, isMounted, getPreciseEventTarget, call, throwError, inject, loadingBarApiInjectionKey, cE, NBaseIcon, createKey, ErrorIcon$1 as ErrorIcon, WarningIcon, SuccessIcon, InfoIcon, _export_sfc, useConfigStore, usePlanStore, storeToRefs, watch, createElementBlock, openBlock, createBaseVNode, createBlock, createCommentVNode, createVNode, Fragment, renderList, withCtx, unref, Button, toDisplayString, createTextVNode, normalizeClass, normalizeStyle, vShow, withModifiers, nextTick, isRef, resolveComponent, __unplugin_components_0 as __unplugin_components_0$2, __unplugin_components_4 as __unplugin_components_4$1, getDefaultExportFromCjs, watchEffect, onMounted, deepcopy, provide } from "./index.js";
import { __unplugin_components_12, render_op_label, pinyin_match, swap, __unplugin_components_15 } from "./common.js";
import { internalSelectMenuLight, NInternalSelectMenu, createTmOptions, __unplugin_components_5 } from "./Select.js";
import { inputLight, __unplugin_components_0 } from "./Checkbox.js";
import { __unplugin_components_7 } from "./Avatar.js";
import { __unplugin_components_4, __unplugin_components_1, __unplugin_components_8 } from "./DropDown2.js";
import { Binder, VTarget, VFollower, useAdjustedTo, __unplugin_components_6 } from "./Tooltip.js";
import { createTreeMate } from "./create.js";
import { __unplugin_components_5 as __unplugin_components_5$1 } from "./Table.js";
import { Scrollbar } from "./Scrollbar.js";
import { requireVue } from "./index2.js";
import { IosArrowBack, IosArrowForward } from "./IosArrowForward.js";
import { useMessage } from "./use-message.js";
import { __unplugin_components_9 as __unplugin_components_9$1 } from "./Image.js";
import { NIcon } from "./Icon.js";
import { __unplugin_components_13, __unplugin_components_11 } from "./RadioGroup.js";
import "./download.js";
import "./Add.js";
import "./use-locale.js";
import "./get-slot.js";
import "./Tag.js";
import "./next-frame-once.js";
import "./use-compitable.js";
import "./utils.js";
import "./Forward.js";
import "./Dropdown.js";
function self$1(vars) {
  const {
    boxShadow2
  } = vars;
  return {
    menuBoxShadow: boxShadow2
  };
}
const autoCompleteLight = createTheme({
  name: "AutoComplete",
  common: derived,
  peers: {
    InternalSelectMenu: internalSelectMenuLight,
    Input: inputLight
  },
  self: self$1
});
const style$1 = c([cB("auto-complete", `
 z-index: auto;
 position: relative;
 display: inline-flex;
 width: 100%;
 `), cB("auto-complete-menu", `
 margin: 4px 0;
 box-shadow: var(--n-menu-box-shadow);
 `, [fadeInScaleUpTransition({
  originalTransition: "background-color .3s var(--n-bezier), box-shadow .3s var(--n-bezier)"
})])]);
function mapAutoCompleteOptionsToSelectOptions(options) {
  return options.map(convertAutoCompleteOptionToSelectOption);
}
function convertAutoCompleteOptionToSelectOption(option) {
  var _a, _b;
  if (typeof option === "string") {
    return {
      label: option,
      value: option
    };
  } else if (option.type === "group") {
    const groupOption = {
      type: "group",
      label: (_a = option.label) !== null && _a !== void 0 ? _a : option.name,
      value: (_b = option.value) !== null && _b !== void 0 ? _b : option.name,
      key: option.key || option.name,
      children: option.children.map((groupOption2) => convertAutoCompleteOptionToSelectOption(groupOption2))
    };
    return groupOption;
  } else {
    return option;
  }
}
const autoCompleteProps = Object.assign(Object.assign({}, useTheme.props), {
  to: useAdjustedTo.propTo,
  menuProps: Object,
  append: Boolean,
  bordered: {
    type: Boolean,
    default: void 0
  },
  clearable: {
    type: Boolean,
    default: void 0
  },
  defaultValue: {
    type: String,
    default: null
  },
  loading: {
    type: Boolean,
    default: void 0
  },
  disabled: {
    type: Boolean,
    default: void 0
  },
  placeholder: String,
  placement: {
    type: String,
    default: "bottom-start"
  },
  value: String,
  blurAfterSelect: Boolean,
  clearAfterSelect: Boolean,
  getShow: Function,
  showEmpty: Boolean,
  inputProps: Object,
  renderOption: Function,
  renderLabel: Function,
  size: String,
  options: {
    type: Array,
    default: () => []
  },
  zIndex: Number,
  status: String,
  "onUpdate:value": [Function, Array],
  onUpdateValue: [Function, Array],
  onSelect: [Function, Array],
  onBlur: [Function, Array],
  onFocus: [Function, Array],
  // deprecated
  onInput: [Function, Array]
});
const __unplugin_components_2$1 = defineComponent({
  name: "AutoComplete",
  props: autoCompleteProps,
  slots: Object,
  setup(props) {
    const {
      mergedBorderedRef,
      namespaceRef,
      mergedClsPrefixRef,
      inlineThemeDisabled
    } = useConfig(props);
    const formItem = useFormItem(props);
    const {
      mergedSizeRef,
      mergedDisabledRef,
      mergedStatusRef
    } = formItem;
    const triggerElRef = ref(null);
    const menuInstRef = ref(null);
    const uncontrolledValueRef = ref(props.defaultValue);
    const controlledValueRef = toRef(props, "value");
    const mergedValueRef = useMergedState(controlledValueRef, uncontrolledValueRef);
    const canBeActivatedRef = ref(false);
    const isComposingRef = ref(false);
    const themeRef = useTheme("AutoComplete", "-auto-complete", style$1, autoCompleteLight, props, mergedClsPrefixRef);
    const selectOptionsRef = computed(() => {
      return mapAutoCompleteOptionsToSelectOptions(props.options);
    });
    const mergedShowOptionsRef = computed(() => {
      const {
        getShow
      } = props;
      if (getShow) {
        return getShow(mergedValueRef.value || "");
      }
      return !!mergedValueRef.value;
    });
    const activeRef = computed(() => {
      return mergedShowOptionsRef.value && canBeActivatedRef.value && (props.showEmpty ? true : !!selectOptionsRef.value.length);
    });
    const treeMateRef = computed(() => createTreeMate(selectOptionsRef.value, createTmOptions("value", "children")));
    function doUpdateValue(value) {
      const {
        "onUpdate:value": _onUpdateValue,
        onUpdateValue,
        onInput
      } = props;
      const {
        nTriggerFormInput,
        nTriggerFormChange
      } = formItem;
      if (onUpdateValue) call(onUpdateValue, value);
      if (_onUpdateValue) call(_onUpdateValue, value);
      if (onInput) call(onInput, value);
      uncontrolledValueRef.value = value;
      nTriggerFormInput();
      nTriggerFormChange();
    }
    function doSelect(value) {
      const {
        onSelect
      } = props;
      const {
        nTriggerFormInput,
        nTriggerFormChange
      } = formItem;
      if (onSelect) call(onSelect, value);
      nTriggerFormInput();
      nTriggerFormChange();
    }
    function doBlur(e) {
      const {
        onBlur
      } = props;
      const {
        nTriggerFormBlur
      } = formItem;
      if (onBlur) call(onBlur, e);
      nTriggerFormBlur();
    }
    function doFocus(e) {
      const {
        onFocus
      } = props;
      const {
        nTriggerFormFocus
      } = formItem;
      if (onFocus) call(onFocus, e);
      nTriggerFormFocus();
    }
    function handleCompositionStart() {
      isComposingRef.value = true;
    }
    function handleCompositionEnd() {
      window.setTimeout(() => {
        isComposingRef.value = false;
      }, 0);
    }
    function handleKeyDown(e) {
      var _a, _b, _c;
      switch (e.key) {
        case "Enter":
          if (!isComposingRef.value) {
            const pendingOptionTmNode = (_a = menuInstRef.value) === null || _a === void 0 ? void 0 : _a.getPendingTmNode();
            if (pendingOptionTmNode) {
              select(pendingOptionTmNode.rawNode);
              e.preventDefault();
            }
          }
          break;
        case "ArrowDown":
          (_b = menuInstRef.value) === null || _b === void 0 ? void 0 : _b.next();
          break;
        case "ArrowUp":
          (_c = menuInstRef.value) === null || _c === void 0 ? void 0 : _c.prev();
          break;
      }
    }
    function select(option) {
      if ((option === null || option === void 0 ? void 0 : option.value) !== void 0) {
        doSelect(option.value);
        if (props.clearAfterSelect) {
          doUpdateValue(null);
        } else if (option.label !== void 0) {
          doUpdateValue(props.append ? `${mergedValueRef.value}${option.label}` : option.label);
        }
        canBeActivatedRef.value = false;
        if (props.blurAfterSelect) {
          blur();
        }
      }
    }
    function handleClear() {
      doUpdateValue(null);
    }
    function handleFocus(e) {
      canBeActivatedRef.value = true;
      doFocus(e);
    }
    function handleBlur(e) {
      canBeActivatedRef.value = false;
      doBlur(e);
    }
    function handleInput(value) {
      canBeActivatedRef.value = true;
      doUpdateValue(value);
    }
    function handleToggle(option) {
      select(option.rawNode);
    }
    function handleClickOutsideMenu(e) {
      var _a;
      if (!((_a = triggerElRef.value) === null || _a === void 0 ? void 0 : _a.contains(getPreciseEventTarget(e)))) {
        canBeActivatedRef.value = false;
      }
    }
    function blur() {
      var _a, _b;
      if ((_a = triggerElRef.value) === null || _a === void 0 ? void 0 : _a.contains(document.activeElement)) {
        (_b = document.activeElement) === null || _b === void 0 ? void 0 : _b.blur();
      }
    }
    const cssVarsRef = computed(() => {
      const {
        common: {
          cubicBezierEaseInOut
        },
        self: {
          menuBoxShadow
        }
      } = themeRef.value;
      return {
        "--n-menu-box-shadow": menuBoxShadow,
        "--n-bezier": cubicBezierEaseInOut
      };
    });
    const themeClassHandle = inlineThemeDisabled ? useThemeClass("auto-complete", void 0, cssVarsRef, props) : void 0;
    const inputInstRef = ref(null);
    const exposedMethods = {
      focus: () => {
        var _a;
        (_a = inputInstRef.value) === null || _a === void 0 ? void 0 : _a.focus();
      },
      blur: () => {
        var _a;
        (_a = inputInstRef.value) === null || _a === void 0 ? void 0 : _a.blur();
      }
    };
    return {
      focus: exposedMethods.focus,
      blur: exposedMethods.blur,
      inputInstRef,
      uncontrolledValue: uncontrolledValueRef,
      mergedValue: mergedValueRef,
      isMounted: isMounted(),
      adjustedTo: useAdjustedTo(props),
      menuInstRef,
      triggerElRef,
      treeMate: treeMateRef,
      mergedSize: mergedSizeRef,
      mergedDisabled: mergedDisabledRef,
      active: activeRef,
      mergedStatus: mergedStatusRef,
      handleClear,
      handleFocus,
      handleBlur,
      handleInput,
      handleToggle,
      handleClickOutsideMenu,
      handleCompositionStart,
      handleCompositionEnd,
      handleKeyDown,
      mergedTheme: themeRef,
      cssVars: inlineThemeDisabled ? void 0 : cssVarsRef,
      themeClass: themeClassHandle === null || themeClassHandle === void 0 ? void 0 : themeClassHandle.themeClass,
      onRender: themeClassHandle === null || themeClassHandle === void 0 ? void 0 : themeClassHandle.onRender,
      mergedBordered: mergedBorderedRef,
      namespace: namespaceRef,
      mergedClsPrefix: mergedClsPrefixRef
    };
  },
  render() {
    const {
      mergedClsPrefix
    } = this;
    return h("div", {
      class: `${mergedClsPrefix}-auto-complete`,
      ref: "triggerElRef",
      onKeydown: this.handleKeyDown,
      onCompositionstart: this.handleCompositionStart,
      onCompositionend: this.handleCompositionEnd
    }, h(Binder, null, {
      default: () => [h(VTarget, null, {
        default: () => {
          const defaultSlot = this.$slots.default;
          if (defaultSlot) {
            return getFirstSlotVNodeWithTypedProps("default", defaultSlot, {
              handleInput: this.handleInput,
              handleFocus: this.handleFocus,
              handleBlur: this.handleBlur,
              value: this.mergedValue
            });
          }
          const {
            mergedTheme
          } = this;
          return h(__unplugin_components_0, {
            ref: "inputInstRef",
            status: this.mergedStatus,
            theme: mergedTheme.peers.Input,
            themeOverrides: mergedTheme.peerOverrides.Input,
            bordered: this.mergedBordered,
            value: this.mergedValue,
            placeholder: this.placeholder,
            size: this.mergedSize,
            disabled: this.mergedDisabled,
            clearable: this.clearable,
            loading: this.loading,
            inputProps: this.inputProps,
            onClear: this.handleClear,
            onFocus: this.handleFocus,
            onUpdateValue: this.handleInput,
            onBlur: this.handleBlur
          }, {
            suffix: () => {
              var _a, _b;
              return (_b = (_a = this.$slots).suffix) === null || _b === void 0 ? void 0 : _b.call(_a);
            },
            prefix: () => {
              var _a, _b;
              return (_b = (_a = this.$slots).prefix) === null || _b === void 0 ? void 0 : _b.call(_a);
            }
          });
        }
      }), h(VFollower, {
        show: this.active,
        to: this.adjustedTo,
        containerClass: this.namespace,
        zIndex: this.zIndex,
        teleportDisabled: this.adjustedTo === useAdjustedTo.tdkey,
        placement: this.placement,
        width: "target"
      }, {
        default: () => h(Transition, {
          name: "fade-in-scale-up-transition",
          appear: this.isMounted
        }, {
          default: () => {
            var _a;
            (_a = this.onRender) === null || _a === void 0 ? void 0 : _a.call(this);
            if (!this.active) return null;
            const {
              menuProps
            } = this;
            return withDirectives(h(NInternalSelectMenu, Object.assign({}, menuProps, {
              clsPrefix: mergedClsPrefix,
              ref: "menuInstRef",
              theme: this.mergedTheme.peers.InternalSelectMenu,
              themeOverrides: this.mergedTheme.peerOverrides.InternalSelectMenu,
              "auto-pending": true,
              class: [`${mergedClsPrefix}-auto-complete-menu`, this.themeClass, menuProps === null || menuProps === void 0 ? void 0 : menuProps.class],
              style: [menuProps === null || menuProps === void 0 ? void 0 : menuProps.style, this.cssVars],
              treeMate: this.treeMate,
              multiple: false,
              renderLabel: this.renderLabel,
              renderOption: this.renderOption,
              size: "medium",
              onToggle: this.handleToggle
            }), {
              empty: () => {
                var _a2, _b;
                return (_b = (_a2 = this.$slots).empty) === null || _b === void 0 ? void 0 : _b.call(_a2);
              }
            }), [[clickoutside, this.handleClickOutsideMenu, void 0, {
              capture: true
            }]]);
          }
        })
      })]
    }));
  }
});
function useLoadingBar() {
  const loadingBar = inject(loadingBarApiInjectionKey, null);
  if (loadingBar === null) {
    throwError("use-loading-bar", "No outer <n-loading-bar-provider /> founded.");
  }
  return loadingBar;
}
const commonVariables = {
  titleFontSizeSmall: "26px",
  titleFontSizeMedium: "32px",
  titleFontSizeLarge: "40px",
  titleFontSizeHuge: "48px",
  fontSizeSmall: "14px",
  fontSizeMedium: "14px",
  fontSizeLarge: "15px",
  fontSizeHuge: "16px",
  iconSizeSmall: "64px",
  iconSizeMedium: "80px",
  iconSizeLarge: "100px",
  iconSizeHuge: "125px",
  iconColor418: void 0,
  iconColor404: void 0,
  iconColor403: void 0,
  iconColor500: void 0
};
function self(vars) {
  const {
    textColor2,
    textColor1,
    errorColor,
    successColor,
    infoColor,
    warningColor,
    lineHeight,
    fontWeightStrong
  } = vars;
  return Object.assign(Object.assign({}, commonVariables), {
    lineHeight,
    titleFontWeight: fontWeightStrong,
    titleTextColor: textColor1,
    textColor: textColor2,
    iconColorError: errorColor,
    iconColorSuccess: successColor,
    iconColorInfo: infoColor,
    iconColorWarning: warningColor
  });
}
const resultLight = {
  common: derived,
  self
};
function render403() {
  return h("svg", {
    xmlns: "http://www.w3.org/2000/svg",
    viewBox: "0 0 36 36"
  }, h("path", {
    fill: "#EF9645",
    d: "M15.5 2.965c1.381 0 2.5 1.119 2.5 2.5v.005L20.5.465c1.381 0 2.5 1.119 2.5 2.5V4.25l2.5-1.535c1.381 0 2.5 1.119 2.5 2.5V8.75L29 18H15.458L15.5 2.965z"
  }), h("path", {
    fill: "#FFDC5D",
    d: "M4.625 16.219c1.381-.611 3.354.208 4.75 2.188.917 1.3 1.187 3.151 2.391 3.344.46.073 1.234-.313 1.234-1.397V4.5s0-2 2-2 2 2 2 2v11.633c0-.029 1-.064 1-.082V2s0-2 2-2 2 2 2 2v14.053c0 .017 1 .041 1 .069V4.25s0-2 2-2 2 2 2 2v12.638c0 .118 1 .251 1 .398V8.75s0-2 2-2 2 2 2 2V24c0 6.627-5.373 12-12 12-4.775 0-8.06-2.598-9.896-5.292C8.547 28.423 8.096 26.051 8 25.334c0 0-.123-1.479-1.156-2.865-1.469-1.969-2.5-3.156-3.125-3.866-.317-.359-.625-1.707.906-2.384z"
  }));
}
function render404() {
  return h("svg", {
    xmlns: "http://www.w3.org/2000/svg",
    viewBox: "0 0 36 36"
  }, h("circle", {
    fill: "#FFCB4C",
    cx: "18",
    cy: "17.018",
    r: "17"
  }), h("path", {
    fill: "#65471B",
    d: "M14.524 21.036c-.145-.116-.258-.274-.312-.464-.134-.46.13-.918.59-1.021 4.528-1.021 7.577 1.363 7.706 1.465.384.306.459.845.173 1.205-.286.358-.828.401-1.211.097-.11-.084-2.523-1.923-6.182-1.098-.274.061-.554-.016-.764-.184z"
  }), h("ellipse", {
    fill: "#65471B",
    cx: "13.119",
    cy: "11.174",
    rx: "2.125",
    ry: "2.656"
  }), h("ellipse", {
    fill: "#65471B",
    cx: "24.375",
    cy: "12.236",
    rx: "2.125",
    ry: "2.656"
  }), h("path", {
    fill: "#F19020",
    d: "M17.276 35.149s1.265-.411 1.429-1.352c.173-.972-.624-1.167-.624-1.167s1.041-.208 1.172-1.376c.123-1.101-.861-1.363-.861-1.363s.97-.4 1.016-1.539c.038-.959-.995-1.428-.995-1.428s5.038-1.221 5.556-1.341c.516-.12 1.32-.615 1.069-1.694-.249-1.08-1.204-1.118-1.697-1.003-.494.115-6.744 1.566-8.9 2.068l-1.439.334c-.54.127-.785-.11-.404-.512.508-.536.833-1.129.946-2.113.119-1.035-.232-2.313-.433-2.809-.374-.921-1.005-1.649-1.734-1.899-1.137-.39-1.945.321-1.542 1.561.604 1.854.208 3.375-.833 4.293-2.449 2.157-3.588 3.695-2.83 6.973.828 3.575 4.377 5.876 7.952 5.048l3.152-.681z"
  }), h("path", {
    fill: "#65471B",
    d: "M9.296 6.351c-.164-.088-.303-.224-.391-.399-.216-.428-.04-.927.393-1.112 4.266-1.831 7.699-.043 7.843.034.433.231.608.747.391 1.154-.216.405-.74.546-1.173.318-.123-.063-2.832-1.432-6.278.047-.257.109-.547.085-.785-.042zm12.135 3.75c-.156-.098-.286-.243-.362-.424-.187-.442.023-.927.468-1.084 4.381-1.536 7.685.48 7.823.567.415.26.555.787.312 1.178-.242.39-.776.495-1.191.238-.12-.072-2.727-1.621-6.267-.379-.266.091-.553.046-.783-.096z"
  }));
}
function render418() {
  return h("svg", {
    xmlns: "http://www.w3.org/2000/svg",
    viewBox: "0 0 36 36"
  }, h("ellipse", {
    fill: "#292F33",
    cx: "18",
    cy: "26",
    rx: "18",
    ry: "10"
  }), h("ellipse", {
    fill: "#66757F",
    cx: "18",
    cy: "24",
    rx: "18",
    ry: "10"
  }), h("path", {
    fill: "#E1E8ED",
    d: "M18 31C3.042 31 1 16 1 12h34c0 2-1.958 19-17 19z"
  }), h("path", {
    fill: "#77B255",
    d: "M35 12.056c0 5.216-7.611 9.444-17 9.444S1 17.271 1 12.056C1 6.84 8.611 3.611 18 3.611s17 3.229 17 8.445z"
  }), h("ellipse", {
    fill: "#A6D388",
    cx: "18",
    cy: "13",
    rx: "15",
    ry: "7"
  }), h("path", {
    d: "M21 17c-.256 0-.512-.098-.707-.293-2.337-2.337-2.376-4.885-.125-8.262.739-1.109.9-2.246.478-3.377-.461-1.236-1.438-1.996-1.731-2.077-.553 0-.958-.443-.958-.996 0-.552.491-.995 1.043-.995.997 0 2.395 1.153 3.183 2.625 1.034 1.933.91 4.039-.351 5.929-1.961 2.942-1.531 4.332-.125 5.738.391.391.391 1.023 0 1.414-.195.196-.451.294-.707.294zm-6-2c-.256 0-.512-.098-.707-.293-2.337-2.337-2.376-4.885-.125-8.262.727-1.091.893-2.083.494-2.947-.444-.961-1.431-1.469-1.684-1.499-.552 0-.989-.447-.989-1 0-.552.458-1 1.011-1 .997 0 2.585.974 3.36 2.423.481.899 1.052 2.761-.528 5.131-1.961 2.942-1.531 4.332-.125 5.738.391.391.391 1.023 0 1.414-.195.197-.451.295-.707.295z",
    fill: "#5C913B"
  }));
}
function render500() {
  return h("svg", {
    xmlns: "http://www.w3.org/2000/svg",
    viewBox: "0 0 36 36"
  }, h("path", {
    fill: "#FFCC4D",
    d: "M36 18c0 9.941-8.059 18-18 18-9.94 0-18-8.059-18-18C0 8.06 8.06 0 18 0c9.941 0 18 8.06 18 18"
  }), h("ellipse", {
    fill: "#664500",
    cx: "18",
    cy: "27",
    rx: "5",
    ry: "6"
  }), h("path", {
    fill: "#664500",
    d: "M5.999 11c-.208 0-.419-.065-.599-.2-.442-.331-.531-.958-.2-1.4C8.462 5.05 12.816 5 13 5c.552 0 1 .448 1 1 0 .551-.445.998-.996 1-.155.002-3.568.086-6.204 3.6-.196.262-.497.4-.801.4zm24.002 0c-.305 0-.604-.138-.801-.4-2.64-3.521-6.061-3.598-6.206-3.6-.55-.006-.994-.456-.991-1.005C22.006 5.444 22.45 5 23 5c.184 0 4.537.05 7.8 4.4.332.442.242 1.069-.2 1.4-.18.135-.39.2-.599.2zm-16.087 4.5l1.793-1.793c.391-.391.391-1.023 0-1.414s-1.023-.391-1.414 0L12.5 14.086l-1.793-1.793c-.391-.391-1.023-.391-1.414 0s-.391 1.023 0 1.414l1.793 1.793-1.793 1.793c-.391.391-.391 1.023 0 1.414.195.195.451.293.707.293s.512-.098.707-.293l1.793-1.793 1.793 1.793c.195.195.451.293.707.293s.512-.098.707-.293c.391-.391.391-1.023 0-1.414L13.914 15.5zm11 0l1.793-1.793c.391-.391.391-1.023 0-1.414s-1.023-.391-1.414 0L23.5 14.086l-1.793-1.793c-.391-.391-1.023-.391-1.414 0s-.391 1.023 0 1.414l1.793 1.793-1.793 1.793c-.391.391-.391 1.023 0 1.414.195.195.451.293.707.293s.512-.098.707-.293l1.793-1.793 1.793 1.793c.195.195.451.293.707.293s.512-.098.707-.293c.391-.391.391-1.023 0-1.414L24.914 15.5z"
  }));
}
const style = cB("result", `
 color: var(--n-text-color);
 line-height: var(--n-line-height);
 font-size: var(--n-font-size);
 transition:
 color .3s var(--n-bezier);
`, [cB("result-icon", `
 display: flex;
 justify-content: center;
 transition: color .3s var(--n-bezier);
 `, [cE("status-image", `
 font-size: var(--n-icon-size);
 width: 1em;
 height: 1em;
 `), cB("base-icon", `
 color: var(--n-icon-color);
 font-size: var(--n-icon-size);
 `)]), cB("result-content", {
  marginTop: "24px"
}), cB("result-footer", `
 margin-top: 24px;
 text-align: center;
 `), cB("result-header", [cE("title", `
 margin-top: 16px;
 font-weight: var(--n-title-font-weight);
 transition: color .3s var(--n-bezier);
 text-align: center;
 color: var(--n-title-text-color);
 font-size: var(--n-title-font-size);
 `), cE("description", `
 margin-top: 4px;
 text-align: center;
 font-size: var(--n-font-size);
 `)])]);
const iconRenderMap = {
  403: render403,
  404: render404,
  418: render418,
  500: render500,
  info: () => h(InfoIcon, null),
  success: () => h(SuccessIcon, null),
  warning: () => h(WarningIcon, null),
  error: () => h(ErrorIcon, null)
};
const resultProps = Object.assign(Object.assign({}, useTheme.props), {
  size: {
    type: String,
    default: "medium"
  },
  status: {
    type: String,
    default: "info"
  },
  title: String,
  description: String
});
const __unplugin_components_18 = defineComponent({
  name: "Result",
  props: resultProps,
  slots: Object,
  setup(props) {
    const {
      mergedClsPrefixRef,
      inlineThemeDisabled
    } = useConfig(props);
    const themeRef = useTheme("Result", "-result", style, resultLight, props, mergedClsPrefixRef);
    const cssVarsRef = computed(() => {
      const {
        size,
        status
      } = props;
      const {
        common: {
          cubicBezierEaseInOut
        },
        self: {
          textColor,
          lineHeight,
          titleTextColor,
          titleFontWeight,
          [createKey("iconColor", status)]: iconColor,
          [createKey("fontSize", size)]: fontSize,
          [createKey("titleFontSize", size)]: titleFontSize,
          [createKey("iconSize", size)]: iconSize
        }
      } = themeRef.value;
      return {
        "--n-bezier": cubicBezierEaseInOut,
        "--n-font-size": fontSize,
        "--n-icon-size": iconSize,
        "--n-line-height": lineHeight,
        "--n-text-color": textColor,
        "--n-title-font-size": titleFontSize,
        "--n-title-font-weight": titleFontWeight,
        "--n-title-text-color": titleTextColor,
        "--n-icon-color": iconColor || ""
      };
    });
    const themeClassHandle = inlineThemeDisabled ? useThemeClass("result", computed(() => {
      const {
        size,
        status
      } = props;
      let hash = "";
      if (size) {
        hash += size[0];
      }
      if (status) {
        hash += status[0];
      }
      return hash;
    }), cssVarsRef, props) : void 0;
    return {
      mergedClsPrefix: mergedClsPrefixRef,
      cssVars: inlineThemeDisabled ? void 0 : cssVarsRef,
      themeClass: themeClassHandle === null || themeClassHandle === void 0 ? void 0 : themeClassHandle.themeClass,
      onRender: themeClassHandle === null || themeClassHandle === void 0 ? void 0 : themeClassHandle.onRender
    };
  },
  render() {
    var _a;
    const {
      status,
      $slots,
      mergedClsPrefix,
      onRender
    } = this;
    onRender === null || onRender === void 0 ? void 0 : onRender();
    return h("div", {
      class: [`${mergedClsPrefix}-result`, this.themeClass],
      style: this.cssVars
    }, h("div", {
      class: `${mergedClsPrefix}-result-icon`
    }, ((_a = $slots.icon) === null || _a === void 0 ? void 0 : _a.call($slots)) || h(NBaseIcon, {
      clsPrefix: mergedClsPrefix
    }, {
      default: () => iconRenderMap[status]()
    })), h("div", {
      class: `${mergedClsPrefix}-result-header`
    }, this.title ? h("div", {
      class: `${mergedClsPrefix}-result-header__title`
    }, this.title) : null, this.description ? h("div", {
      class: `${mergedClsPrefix}-result-header__description`
    }, this.description) : null), $slots.default && h("div", {
      class: `${mergedClsPrefix}-result-content`
    }, $slots), $slots.footer && h("div", {
      class: `${mergedClsPrefix}-result-footer`
    }, $slots.footer()));
  }
});
const _hoisted_1$3 = { class: "outer" };
const _hoisted_2$2 = { class: "left_box" };
const _hoisted_3$1 = { class: "left_contain" };
const _hoisted_4$1 = ["onClick"];
const _hoisted_5 = ["onDragstart", "onDrop"];
const _hoisted_6 = { class: "facility-name" };
const _hoisted_7 = { class: "avatars" };
const _hoisted_8 = {
  key: 0,
  class: "avatar-wrapper"
};
const _hoisted_9 = ["src"];
const _hoisted_10 = {
  key: 0,
  class: "workaholic"
};
const _hoisted_11 = { class: "waiting" };
const _hoisted_12 = { class: "mid_box" };
const _hoisted_13 = { class: "mid_contain" };
const _hoisted_14 = { class: "avatars" };
const _hoisted_15 = ["src"];
const _hoisted_16 = { class: "mid_contain" };
const _hoisted_17 = { class: "avatars" };
const _hoisted_18 = ["src"];
const _hoisted_19 = { class: "mid_contain" };
const _hoisted_20 = { class: "avatars" };
const _hoisted_21 = ["src"];
const _hoisted_22 = { class: "mid_contain" };
const _hoisted_23 = { class: "avatars" };
const _hoisted_24 = ["src"];
const _hoisted_25 = { class: "mid_contain" };
const _hoisted_26 = { class: "avatars" };
const _hoisted_27 = ["src"];
const _hoisted_28 = { class: "right_box" };
const _hoisted_29 = { class: "right_contain" };
const _hoisted_30 = { class: "avatars" };
const _hoisted_31 = ["src"];
const _hoisted_32 = { class: "right_contain" };
const _hoisted_33 = { class: "avatars" };
const _hoisted_34 = ["src"];
const _hoisted_35 = { class: "right_contain" };
const _hoisted_36 = { class: "avatars" };
const _hoisted_37 = ["src"];
const _hoisted_38 = { class: "right_contain" };
const _hoisted_39 = { class: "avatars" };
const _hoisted_40 = ["src"];
const _hoisted_41 = {
  key: 1,
  class: "type-select"
};
const _hoisted_42 = { class: "select-label" };
const _hoisted_43 = { class: "table-space" };
const _hoisted_44 = { class: "select-label" };
const _hoisted_45 = { class: "table-space group" };
const _sfc_main$4 = {
  __name: "PlanEditor",
  setup(__props, { expose: __expose }) {
    const config_store = useConfigStore();
    const plan_store = usePlanStore();
    const {
      operators,
      groups,
      current_plan: plan,
      workaholic,
      sub_plan,
      backup_plans
    } = storeToRefs(plan_store);
    const { facility_operator_limit } = plan_store;
    const { conf } = storeToRefs(config_store);
    const outer = ref(null);
    const facility_types = [
      { label: "贸易站", value: "贸易站" },
      { label: "制造站", value: "制造站" },
      { label: "发电站", value: "发电站" }
    ];
    const facility = inject("facility");
    const button_type = {
      贸易站: "info",
      制造站: "warning",
      发电站: "primary"
    };
    const operator_limit = computed(() => {
      if (facility.value.startsWith("room") && plan.value[facility.value].name == "发电站") {
        return 1;
      }
      return facility_operator_limit[facility.value] || 0;
    });
    function clear() {
      plan.value[facility.value].name = "";
      nextTick(() => {
        const plans = [];
        for (let i = 0; i < operator_limit.value; ++i) {
          plans.push({
            agent: "",
            group: "",
            replacement: []
          });
        }
        plan.value[facility.value].plans = plans;
      });
    }
    watch(
      () => {
        if (facility.value.startsWith("room")) {
          return plan.value[facility.value].name;
        }
        return "";
      },
      (new_name, old_name) => {
        if (new_name == "发电站") {
          const plans = plan.value[facility.value].plans;
          while (plans.length > operator_limit.value) {
            plans.pop();
          }
        } else if (old_name == "发电站") {
          const plans = plan.value[facility.value].plans;
          while (plans.length < operator_limit.value) {
            plans.push({ agent: "", group: "", replacement: [] });
          }
        }
      }
    );
    const operators_with_none = computed(() => {
      return [{ value: "", label: "（无）" }].concat(operators.value);
    });
    computed(() => {
      return [{ value: "Free", label: "Free" }].concat(operators.value);
    });
    const operators_with_none_free = computed(() => {
      return [{ value: "Free", label: "Free" }].concat(operators_with_none.value);
    });
    const operators_with_none_current = computed(() => {
      return [{ value: "Current", label: "Current" }].concat(operators_with_none.value);
    });
    const operators_with_none_free_current = computed(() => {
      return [{ value: "Current", label: "Current" }].concat(operators_with_none_free.value);
    });
    function operator_options(facility2) {
      if (sub_plan.value == "main") {
        return facility2.startsWith("dorm") ? operators_with_none_free.value : operators_with_none.value;
      } else {
        return facility2.startsWith("dorm") ? operators_with_none_free_current.value : operators_with_none_current.value;
      }
    }
    const right_side_facility_name = computed(() => {
      if (facility.value.startsWith("dormitory")) {
        return "宿舍";
      } else if (facility.value == "central") {
        return "控制中枢";
      } else if (facility.value == "contact") {
        return "办公室";
      } else if (facility.value == "meeting") {
        return "会客室";
      } else if (facility.value == "factory") {
        return "加工站";
      } else if (facility.value == "train") {
        return "训练室（仅可安排协助位）";
      } else {
        return "未知";
      }
    });
    const facility_empty = computed(() => {
      let empty = true;
      for (const i of plan.value[facility.value].plans) {
        if (i.agent) {
          empty = false;
          break;
        }
      }
      return empty;
    });
    const color_map = computed(() => {
      const count = groups.value.length;
      const result = {};
      for (let i = 0; i < count; ++i) {
        result[groups.value[i]] = `5px solid hsl(${360 / count * i}, 80%, 45%)`;
      }
      result[""] = "none";
      return result;
    });
    function drag_facility(room, event) {
      event.dataTransfer.setData("text/plain", room);
      event.dataTransfer.dropEffect = "move";
    }
    function drop_facility(target, event) {
      const source = event.dataTransfer.getData("text/plain");
      swap(source, target, plan.value);
      if (sub_plan.value == "main") {
        backup_plans.value.forEach((item) => {
          swap(source, target, item.plan);
        });
      }
      event.preventDefault();
    }
    __expose({
      outer
    });
    function fill_with_free() {
      for (let i = 0; i < operator_limit.value; ++i) {
        if (plan.value[facility.value].plans[i].agent == "") {
          plan.value[facility.value].plans[i].agent = "Free";
        }
      }
    }
    const trading_products = [
      { label: "赤金订单", value: "lmd" },
      { label: "合成玉订单", value: "orundum" }
    ];
    const factory_products = [
      { label: "赤金", value: "gold" },
      { label: "中级作战记录", value: "exp3" },
      { label: "源石碎片", value: "orirock" }
    ];
    const render_product = (option) => {
      return h(
        "div",
        {
          style: {
            display: "flex",
            alignItems: "center",
            gap: "12px"
          }
        },
        [
          h(__unplugin_components_7, {
            src: "/product/" + option.value + ".png",
            round: true,
            size: "small"
          }),
          option.label
        ]
      );
    };
    const fia_list = computed(() => {
      for (let i = 1; i <= 4; ++i) {
        for (let j = 0; j < 5; ++j) {
          if (plan.value[`dormitory_${i}`].plans[j].agent == "菲亚梅塔") {
            return plan.value[`dormitory_${i}`].plans[j].replacement;
          }
        }
      }
      return [];
    });
    function set_facility(e) {
      if (facility.value == e) {
        facility.value = "";
      } else {
        facility.value = e;
      }
    }
    return (_ctx, _cache) => {
      const _component_n_button = Button;
      const _component_n_select = __unplugin_components_5;
      const _component_help_text = __unplugin_components_0$1;
      const _component_n_space = __unplugin_components_12;
      const _component_n_input = __unplugin_components_0;
      const _component_slick_operator_select = __unplugin_components_16;
      const _component_n_form_item = __unplugin_components_14;
      return openBlock(), createElementBlock("div", {
        class: "plan-container",
        ref_key: "outer",
        ref: outer
      }, [
        createBaseVNode("div", _hoisted_1$3, [
          createBaseVNode("div", _hoisted_2$2, [
            (openBlock(), createElementBlock(Fragment, null, renderList(3, (row) => {
              return createBaseVNode("div", _hoisted_3$1, [
                (openBlock(true), createElementBlock(Fragment, null, renderList([`room_${row}_1`, `room_${row}_2`, `room_${row}_3`], (r) => {
                  return openBlock(), createElementBlock("div", {
                    key: r,
                    onClick: ($event) => set_facility(r),
                    class: normalizeClass([button_type[unref(plan)[r].name], r === unref(facility) ? "true" : "false"])
                  }, [
                    ["制造站", "贸易站"].includes(unref(plan)[r].name) ? (openBlock(), createElementBlock("div", {
                      key: 0,
                      class: "product-bg",
                      style: normalizeStyle({
                        "background-image": `url(/product/${unref(plan)[r].product}.png)`
                      })
                    }, null, 4)) : createCommentVNode("", true),
                    withDirectives(createBaseVNode("div", {
                      draggable: "true",
                      onDragstart: ($event) => drag_facility(r, $event),
                      onDragover: _cache[0] || (_cache[0] = withModifiers(() => {
                      }, ["prevent"])),
                      onDragenter: _cache[1] || (_cache[1] = withModifiers(() => {
                      }, ["prevent"])),
                      onDrop: ($event) => drop_facility(r, $event),
                      class: "draggable"
                    }, [
                      createBaseVNode("div", _hoisted_6, toDisplayString(unref(plan)[r].name), 1),
                      createBaseVNode("div", _hoisted_7, [
                        (openBlock(true), createElementBlock(Fragment, null, renderList(unref(plan)[r].plans, (i) => {
                          return openBlock(), createElementBlock(Fragment, null, [
                            i.agent ? (openBlock(), createElementBlock("div", _hoisted_8, [
                              createBaseVNode("img", {
                                src: `avatar/${i.agent}.webp`,
                                width: "45",
                                height: "45",
                                style: normalizeStyle({ "border-bottom": unref(color_map)[i.group] }),
                                draggable: "false"
                              }, null, 12, _hoisted_9),
                              unref(workaholic).includes(i.agent) && !unref(fia_list).includes(i.agent) ? (openBlock(), createElementBlock("div", _hoisted_10)) : createCommentVNode("", true)
                            ])) : createCommentVNode("", true)
                          ], 64);
                        }), 256))
                      ])
                    ], 40, _hoisted_5), [
                      [vShow, unref(plan)[r].name]
                    ]),
                    withDirectives(createBaseVNode("div", _hoisted_11, _cache[13] || (_cache[13] = [
                      createBaseVNode("div", null, "待建造", -1)
                    ]), 512), [
                      [vShow, !unref(plan)[r].name]
                    ])
                  ], 10, _hoisted_4$1);
                }), 128))
              ]);
            }), 64))
          ]),
          createBaseVNode("div", _hoisted_12, [
            createBaseVNode("div", _hoisted_13, [
              createVNode(_component_n_button, {
                secondary: unref(facility) != "central",
                class: "facility-5",
                onClick: _cache[2] || (_cache[2] = ($event) => set_facility("central"))
              }, {
                default: withCtx(() => [
                  createBaseVNode("div", null, [
                    _cache[14] || (_cache[14] = createBaseVNode("div", { class: "facility-name" }, "控制中枢", -1)),
                    createBaseVNode("div", _hoisted_14, [
                      (openBlock(true), createElementBlock(Fragment, null, renderList(unref(plan).central.plans, (i) => {
                        return openBlock(), createElementBlock("img", {
                          src: `avatar/${i.agent}.webp`,
                          width: "45",
                          height: "45",
                          style: normalizeStyle({ "border-bottom": unref(color_map)[i.group] })
                        }, null, 12, _hoisted_15);
                      }), 256))
                    ])
                  ])
                ]),
                _: 1
              }, 8, ["secondary"])
            ]),
            createBaseVNode("div", _hoisted_16, [
              createVNode(_component_n_button, {
                secondary: unref(facility) != "dormitory_1",
                class: "facility-5",
                onClick: _cache[3] || (_cache[3] = ($event) => set_facility("dormitory_1"))
              }, {
                default: withCtx(() => [
                  createBaseVNode("div", null, [
                    _cache[15] || (_cache[15] = createBaseVNode("div", { class: "facility-name" }, "宿舍1", -1)),
                    createBaseVNode("div", _hoisted_17, [
                      (openBlock(true), createElementBlock(Fragment, null, renderList(unref(plan).dormitory_1.plans, (i) => {
                        return openBlock(), createElementBlock("img", {
                          src: `avatar/${i.agent}.webp`,
                          width: "45",
                          height: "45",
                          style: normalizeStyle({ "border-bottom": unref(color_map)[i.group] })
                        }, null, 12, _hoisted_18);
                      }), 256))
                    ])
                  ])
                ]),
                _: 1
              }, 8, ["secondary"])
            ]),
            createBaseVNode("div", _hoisted_19, [
              createVNode(_component_n_button, {
                secondary: unref(facility) != "dormitory_2",
                class: "facility-5",
                onClick: _cache[4] || (_cache[4] = ($event) => set_facility("dormitory_2"))
              }, {
                default: withCtx(() => [
                  createBaseVNode("div", null, [
                    _cache[16] || (_cache[16] = createBaseVNode("div", { class: "facility-name" }, "宿舍2", -1)),
                    createBaseVNode("div", _hoisted_20, [
                      (openBlock(true), createElementBlock(Fragment, null, renderList(unref(plan).dormitory_2.plans, (i) => {
                        return openBlock(), createElementBlock("img", {
                          src: `avatar/${i.agent}.webp`,
                          width: "45",
                          height: "45",
                          style: normalizeStyle({ "border-bottom": unref(color_map)[i.group] })
                        }, null, 12, _hoisted_21);
                      }), 256))
                    ])
                  ])
                ]),
                _: 1
              }, 8, ["secondary"])
            ]),
            createBaseVNode("div", _hoisted_22, [
              createVNode(_component_n_button, {
                secondary: unref(facility) != "dormitory_3",
                class: "facility-5",
                onClick: _cache[5] || (_cache[5] = ($event) => set_facility("dormitory_3"))
              }, {
                default: withCtx(() => [
                  createBaseVNode("div", null, [
                    _cache[17] || (_cache[17] = createBaseVNode("div", { class: "facility-name" }, "宿舍3", -1)),
                    createBaseVNode("div", _hoisted_23, [
                      (openBlock(true), createElementBlock(Fragment, null, renderList(unref(plan).dormitory_3.plans, (i) => {
                        return openBlock(), createElementBlock("img", {
                          src: `avatar/${i.agent}.webp`,
                          width: "45",
                          height: "45",
                          style: normalizeStyle({ "border-bottom": unref(color_map)[i.group] })
                        }, null, 12, _hoisted_24);
                      }), 256))
                    ])
                  ])
                ]),
                _: 1
              }, 8, ["secondary"])
            ]),
            createBaseVNode("div", _hoisted_25, [
              createVNode(_component_n_button, {
                secondary: unref(facility) != "dormitory_4",
                class: "facility-5",
                onClick: _cache[6] || (_cache[6] = ($event) => set_facility("dormitory_4"))
              }, {
                default: withCtx(() => [
                  createBaseVNode("div", null, [
                    _cache[18] || (_cache[18] = createBaseVNode("div", { class: "facility-name" }, "宿舍4", -1)),
                    createBaseVNode("div", _hoisted_26, [
                      (openBlock(true), createElementBlock(Fragment, null, renderList(unref(plan).dormitory_4.plans, (i) => {
                        return openBlock(), createElementBlock("img", {
                          src: `avatar/${i.agent}.webp`,
                          width: "45",
                          height: "45",
                          style: normalizeStyle({ "border-bottom": unref(color_map)[i.group] })
                        }, null, 12, _hoisted_27);
                      }), 256))
                    ])
                  ])
                ]),
                _: 1
              }, 8, ["secondary"])
            ])
          ]),
          createBaseVNode("div", _hoisted_28, [
            createBaseVNode("div", _hoisted_29, [
              createVNode(_component_n_button, {
                secondary: unref(facility) != "meeting",
                class: "facility-2",
                onClick: _cache[7] || (_cache[7] = ($event) => set_facility("meeting"))
              }, {
                default: withCtx(() => [
                  createBaseVNode("div", null, [
                    _cache[19] || (_cache[19] = createBaseVNode("div", { class: "facility-name" }, "会客室", -1)),
                    createBaseVNode("div", _hoisted_30, [
                      (openBlock(true), createElementBlock(Fragment, null, renderList(unref(plan).meeting.plans, (i) => {
                        return openBlock(), createElementBlock("img", {
                          src: `avatar/${i.agent}.webp`,
                          width: "45",
                          height: "45",
                          style: normalizeStyle({ "border-bottom": unref(color_map)[i.group] })
                        }, null, 12, _hoisted_31);
                      }), 256))
                    ])
                  ])
                ]),
                _: 1
              }, 8, ["secondary"])
            ]),
            createBaseVNode("div", _hoisted_32, [
              createVNode(_component_n_button, {
                secondary: unref(facility) != "factory",
                class: "facility-2",
                onClick: _cache[8] || (_cache[8] = ($event) => set_facility("factory"))
              }, {
                default: withCtx(() => [
                  createBaseVNode("div", null, [
                    _cache[20] || (_cache[20] = createBaseVNode("div", { class: "facility-name" }, "加工站", -1)),
                    createBaseVNode("div", _hoisted_33, [
                      (openBlock(true), createElementBlock(Fragment, null, renderList(unref(plan).factory.plans, (i) => {
                        return openBlock(), createElementBlock("img", {
                          src: `avatar/${i.agent}.webp`,
                          width: "45",
                          height: "45",
                          style: normalizeStyle({ "border-bottom": unref(color_map)[i.group] })
                        }, null, 12, _hoisted_34);
                      }), 256))
                    ])
                  ])
                ]),
                _: 1
              }, 8, ["secondary"])
            ]),
            createBaseVNode("div", _hoisted_35, [
              createVNode(_component_n_button, {
                secondary: unref(facility) != "contact",
                class: "facility-2",
                onClick: _cache[9] || (_cache[9] = ($event) => set_facility("contact"))
              }, {
                default: withCtx(() => [
                  createBaseVNode("div", null, [
                    _cache[21] || (_cache[21] = createBaseVNode("div", { class: "facility-name" }, "办公室", -1)),
                    createBaseVNode("div", _hoisted_36, [
                      (openBlock(true), createElementBlock(Fragment, null, renderList(unref(plan).contact.plans, (i) => {
                        return openBlock(), createElementBlock("img", {
                          src: `avatar/${i.agent}.webp`,
                          width: "45",
                          height: "45",
                          style: normalizeStyle({ "border-bottom": unref(color_map)[i.group] })
                        }, null, 12, _hoisted_37);
                      }), 256))
                    ])
                  ])
                ]),
                _: 1
              }, 8, ["secondary"])
            ]),
            createBaseVNode("div", _hoisted_38, [
              createVNode(_component_n_button, {
                secondary: unref(facility) != "train",
                class: "facility-2",
                onClick: _cache[10] || (_cache[10] = ($event) => set_facility("train"))
              }, {
                default: withCtx(() => [
                  createBaseVNode("div", null, [
                    _cache[22] || (_cache[22] = createBaseVNode("div", { class: "facility-name" }, [
                      createBaseVNode("div", null, "协助位"),
                      createBaseVNode("div", null, "训练位")
                    ], -1)),
                    createBaseVNode("div", _hoisted_39, [
                      (openBlock(true), createElementBlock(Fragment, null, renderList(unref(plan).train.plans, (i) => {
                        return openBlock(), createElementBlock("img", {
                          src: `avatar/${i.agent}.webp`,
                          width: "45",
                          height: "45",
                          style: normalizeStyle({ "border-bottom": unref(color_map)[i.group] })
                        }, null, 12, _hoisted_40);
                      }), 256))
                    ])
                  ])
                ]),
                _: 1
              }, 8, ["secondary"])
            ])
          ])
        ]),
        unref(facility) ? (openBlock(), createBlock(_component_n_space, {
          key: 0,
          justify: "center"
        }, {
          default: withCtx(() => [
            createBaseVNode("table", null, [
              createBaseVNode("tbody", null, [
                createBaseVNode("tr", null, [
                  _cache[27] || (_cache[27] = createBaseVNode("td", null, "设施类别：", -1)),
                  createBaseVNode("td", null, [
                    unref(facility).startsWith("room") ? (openBlock(), createBlock(_component_n_select, {
                      key: 0,
                      value: unref(plan)[unref(facility)].name,
                      "onUpdate:value": _cache[11] || (_cache[11] = ($event) => unref(plan)[unref(facility)].name = $event),
                      options: facility_types,
                      class: "type-select"
                    }, null, 8, ["value"])) : (openBlock(), createElementBlock("span", _hoisted_41, toDisplayString(unref(right_side_facility_name)), 1))
                  ]),
                  ["制造站", "贸易站"].includes(unref(plan)[unref(facility)].name) ? (openBlock(), createElementBlock(Fragment, { key: 0 }, [
                    createBaseVNode("td", null, [
                      _cache[24] || (_cache[24] = createTextVNode("产物")),
                      createVNode(_component_help_text, null, {
                        default: withCtx(() => _cache[23] || (_cache[23] = [
                          createTextVNode("切产物功能暂未实装")
                        ])),
                        _: 1
                      })
                    ]),
                    createBaseVNode("td", null, [
                      createVNode(_component_n_select, {
                        value: unref(plan)[unref(facility)].product,
                        "onUpdate:value": _cache[12] || (_cache[12] = ($event) => unref(plan)[unref(facility)].product = $event),
                        options: unref(plan)[unref(facility)].name == "制造站" ? factory_products : trading_products,
                        class: "product-select",
                        "render-label": render_product
                      }, null, 8, ["value", "options"])
                    ])
                  ], 64)) : createCommentVNode("", true),
                  createBaseVNode("td", null, [
                    unref(facility).startsWith("dorm") ? (openBlock(), createBlock(_component_n_button, {
                      key: 0,
                      ghost: "",
                      type: "primary",
                      onClick: fill_with_free
                    }, {
                      default: withCtx(() => _cache[25] || (_cache[25] = [
                        createTextVNode(" 此宿舍内空位填充Free ")
                      ])),
                      _: 1
                    })) : createCommentVNode("", true)
                  ]),
                  createBaseVNode("td", null, [
                    createVNode(_component_n_button, {
                      ghost: "",
                      type: "error",
                      onClick: clear,
                      disabled: unref(facility_empty)
                    }, {
                      default: withCtx(() => _cache[26] || (_cache[26] = [
                        createTextVNode(" 清空此设施内干员 ")
                      ])),
                      _: 1
                    }, 8, ["disabled"])
                  ])
                ])
              ])
            ])
          ]),
          _: 1
        })) : createCommentVNode("", true),
        createVNode(_component_n_space, { justify: "center" }, {
          default: withCtx(() => [
            createBaseVNode("table", null, [
              (openBlock(true), createElementBlock(Fragment, null, renderList(unref(operator_limit), (i) => {
                return openBlock(), createElementBlock("tr", { key: i }, [
                  createBaseVNode("td", _hoisted_42, [
                    unref(facility) == "train" && i == 1 ? (openBlock(), createElementBlock(Fragment, { key: 0 }, [
                      createTextVNode("协助位")
                    ], 64)) : unref(facility) == "train" && i == 2 ? (openBlock(), createElementBlock(Fragment, { key: 1 }, [
                      createTextVNode("训练位")
                    ], 64)) : (openBlock(), createElementBlock(Fragment, { key: 2 }, [
                      createTextVNode("干员：")
                    ], 64))
                  ]),
                  createBaseVNode("td", _hoisted_43, [
                    createVNode(_component_n_select, {
                      filterable: "",
                      options: operator_options(unref(facility)),
                      class: "operator-select",
                      value: unref(plan)[unref(facility)].plans[i - 1].agent,
                      "onUpdate:value": ($event) => unref(plan)[unref(facility)].plans[i - 1].agent = $event,
                      filter: (p, o) => unref(pinyin_match)(o.label, p),
                      "render-label": unref(render_op_label)
                    }, null, 8, ["options", "value", "onUpdate:value", "filter", "render-label"])
                  ]),
                  createBaseVNode("td", _hoisted_44, [
                    _cache[29] || (_cache[29] = createBaseVNode("span", null, "组", -1)),
                    createVNode(_component_help_text, null, {
                      default: withCtx(() => _cache[28] || (_cache[28] = [
                        createTextVNode("可以将有联动基建技能的干员或者心情掉率相等的干员编入同组")
                      ])),
                      _: 1
                    })
                  ]),
                  createBaseVNode("td", _hoisted_45, [
                    createVNode(_component_n_input, {
                      value: unref(plan)[unref(facility)].plans[i - 1].group,
                      "onUpdate:value": ($event) => unref(plan)[unref(facility)].plans[i - 1].group = $event,
                      disabled: !unref(plan)[unref(facility)].plans[i - 1].agent
                    }, null, 8, ["value", "onUpdate:value", "disabled"])
                  ]),
                  _cache[30] || (_cache[30] = createBaseVNode("td", { class: "select-label" }, "替换：", -1)),
                  createBaseVNode("td", null, [
                    createVNode(_component_n_form_item, {
                      "show-label": false,
                      "show-feedback": false
                    }, {
                      default: withCtx(() => [
                        createVNode(_component_slick_operator_select, {
                          disabled: !unref(plan)[unref(facility)].plans[i - 1].agent,
                          modelValue: unref(plan)[unref(facility)].plans[i - 1].replacement,
                          "onUpdate:modelValue": ($event) => unref(plan)[unref(facility)].plans[i - 1].replacement = $event,
                          class: "replacement-select"
                        }, null, 8, ["disabled", "modelValue", "onUpdate:modelValue"])
                      ]),
                      _: 2
                    }, 1024)
                  ])
                ]);
              }), 128))
            ])
          ]),
          _: 1
        })
      ], 512);
    };
  }
};
const __unplugin_components_9 = /* @__PURE__ */ _export_sfc(_sfc_main$4, [["__scopeId", "data-v-ef0a8ed8"]]);
const _sfc_main$3 = {
  __name: "TriggerString",
  props: ["data"],
  emits: ["update"],
  setup(__props, { emit: __emit }) {
    const props = __props;
    const emit = __emit;
    const data = ref(props.data);
    watch(data, () => {
      emit("update", data.value);
    });
    const op_data = computed(() => {
      let x = data.value.match(/op_data.operators\['(.+?)'\].is_resting\(\)/);
      if (x && x[0] == data.value) {
        return {
          type: "in_dorm",
          operator: x[1]
        };
      }
      x = data.value.match(/op_data.operators\['(.+?)'\].is_working\(\)/);
      if (x && x[0] == data.value) {
        return {
          type: "working",
          operator: x[1]
        };
      }
      x = data.value.match(/op_data.operators\['(.+?)'\].current_room/);
      if (x && x[0] == data.value) {
        return {
          type: "room",
          operator: x[1]
        };
      }
      x = data.value.match(/op_data.operators\['(.+?)'\].current_mood\(\)/);
      if (x && x[0] == data.value) {
        return {
          type: "mood",
          operator: x[1]
        };
      }
      if (data.value == "op_data.party_time") {
        return {
          type: "impart"
        };
      }
      return {
        type: "custom"
      };
    });
    const op_type = computed(() => {
      if (op_data.value.type == "custom") {
        return "custom";
      } else if (op_data.value.type == "impart") {
        return "impart";
      } else {
        return "op";
      }
    });
    const type_options = [
      { label: "干员属性", value: "op" },
      { label: "线索交流结束时间", value: "impart" },
      { label: "自定义", value: "custom" }
    ];
    const op_options = [
      { label: "心情", value: "mood" },
      { label: "当前位置", value: "room" },
      { label: "在工作", value: "working" },
      { label: "在休息", value: "in_dorm" }
    ];
    function set_op_type(v) {
      data.value = "";
      if (v == "op") {
        data.value = "op_data.operators['阿米娅'].current_mood()";
      } else if (v == "impart") {
        data.value = "op_data.party_time";
      }
    }
    const plan_store = usePlanStore();
    const { operators } = storeToRefs(plan_store);
    function build_data(op, type) {
      const x = `op_data.operators['${op}'].`;
      if (type == "in_dorm") {
        data.value = x + "is_resting()";
      } else if (type == "working") {
        data.value = x + "is_working()";
      } else if (type == "room") {
        data.value = x + "current_room";
      } else if (type == "mood") {
        data.value = x + "current_mood()";
      } else {
        data.value = "";
      }
    }
    function update_op(op) {
      build_data(op, op_data.value.type);
    }
    function update_type(type) {
      build_data(op_data.value.operator, type);
    }
    const custom_tips = ["True", "False", "None"];
    return (_ctx, _cache) => {
      const _component_n_select = __unplugin_components_5;
      const _component_n_auto_complete = __unplugin_components_2$1;
      return openBlock(), createElementBlock(Fragment, null, [
        createVNode(_component_n_select, {
          "default-value": unref(op_type),
          options: type_options,
          "on-update:value": set_op_type,
          style: { "min-width": "180px" }
        }, null, 8, ["default-value"]),
        unref(op_type) == "custom" ? (openBlock(), createBlock(_component_n_auto_complete, {
          key: 0,
          value: unref(data),
          "onUpdate:value": _cache[0] || (_cache[0] = ($event) => isRef(data) ? data.value = $event : null),
          options: custom_tips,
          "blur-after-select": "",
          "get-show": () => true
        }, null, 8, ["value"])) : createCommentVNode("", true),
        unref(op_type) == "op" ? (openBlock(), createElementBlock(Fragment, { key: 1 }, [
          createVNode(_component_n_select, {
            "default-value": unref(op_data).operator,
            filterable: "",
            options: unref(operators),
            "on-update:value": update_op,
            filter: (p, o) => unref(pinyin_match)(o.label, p),
            "render-label": unref(render_op_label),
            style: { "min-width": "220px" }
          }, null, 8, ["default-value", "options", "filter", "render-label"]),
          createVNode(_component_n_select, {
            "default-value": unref(op_data).type,
            options: op_options,
            "on-update:value": update_type,
            style: { "min-width": "120px" }
          }, null, 8, ["default-value"])
        ], 64)) : createCommentVNode("", true)
      ], 64);
    };
  }
};
const _hoisted_1$2 = { class: "label" };
const _hoisted_2$1 = {
  key: 1,
  class: "label"
};
const _hoisted_3 = { class: "label" };
const _hoisted_4 = {
  key: 1,
  class: "label"
};
const _sfc_main$2 = {
  __name: "TriggerEditor",
  props: ["data"],
  emits: ["update"],
  setup(__props, { emit: __emit }) {
    const props = __props;
    const emit = __emit;
    const left = ref(props.data.left);
    const operator = ref(props.data.operator);
    const right = ref(props.data.right);
    function generate() {
      const result = { left: left.value, operator: operator.value, right: right.value };
      emit("update", result);
    }
    watch([left, operator, right], () => {
      generate();
    });
    const le_options = [
      { label: "表达式", value: "expression" },
      { label: "值", value: "string" }
    ];
    const operator_tips = ["and", "or", "==", "!=", ">", "<", ">=", "<=", "+", "-"];
    return (_ctx, _cache) => {
      const _component_n_select = __unplugin_components_5;
      const _component_trigger_editor = resolveComponent("trigger-editor", true);
      const _component_trigger_string = _sfc_main$3;
      const _component_n_auto_complete = __unplugin_components_2$1;
      const _component_n_table = __unplugin_components_5$1;
      return openBlock(), createBlock(_component_n_table, {
        size: "small",
        "single-line": false
      }, {
        default: withCtx(() => [
          createBaseVNode("tr", null, [
            createBaseVNode("th", null, [
              createBaseVNode("div", _hoisted_1$2, [
                _cache[5] || (_cache[5] = createTextVNode(" 左 ")),
                createVNode(_component_n_select, {
                  "default-value": typeof unref(left) == "object" ? "expression" : "string",
                  "on-update:value": (v) => {
                    left.value = v == "string" ? "" : { left: "", operator: "", right: "" };
                  },
                  options: le_options
                }, null, 8, ["default-value", "on-update:value"])
              ])
            ]),
            createBaseVNode("td", null, [
              typeof unref(left) == "object" ? (openBlock(), createBlock(_component_trigger_editor, {
                key: 0,
                data: unref(left),
                onUpdate: _cache[0] || (_cache[0] = (d) => left.value = d)
              }, null, 8, ["data"])) : (openBlock(), createElementBlock("div", _hoisted_2$1, [
                createVNode(_component_trigger_string, {
                  data: unref(left),
                  onUpdate: _cache[1] || (_cache[1] = (v) => {
                    left.value = v;
                  })
                }, null, 8, ["data"])
              ]))
            ])
          ]),
          createBaseVNode("tr", null, [
            _cache[6] || (_cache[6] = createBaseVNode("th", null, "运算符", -1)),
            createBaseVNode("td", null, [
              createVNode(_component_n_auto_complete, {
                value: unref(operator),
                "onUpdate:value": _cache[2] || (_cache[2] = ($event) => isRef(operator) ? operator.value = $event : null),
                options: operator_tips,
                "blur-after-select": "",
                "get-show": () => true
              }, null, 8, ["value"])
            ])
          ]),
          createBaseVNode("tr", null, [
            createBaseVNode("th", null, [
              createBaseVNode("div", _hoisted_3, [
                _cache[7] || (_cache[7] = createTextVNode(" 右 ")),
                createVNode(_component_n_select, {
                  "default-value": typeof unref(right) == "object" ? "expression" : "string",
                  "on-update:value": (v) => {
                    right.value = v == "string" ? "" : { left: "", operator: "", right: "" };
                  },
                  options: le_options
                }, null, 8, ["default-value", "on-update:value"])
              ])
            ]),
            createBaseVNode("td", null, [
              typeof unref(right) == "object" ? (openBlock(), createBlock(_component_trigger_editor, {
                key: 0,
                data: unref(right),
                onUpdate: _cache[3] || (_cache[3] = (d) => right.value = d)
              }, null, 8, ["data"])) : (openBlock(), createElementBlock("div", _hoisted_4, [
                createVNode(_component_trigger_string, {
                  data: unref(right),
                  onUpdate: _cache[4] || (_cache[4] = (v) => {
                    right.value = v;
                  })
                }, null, 8, ["data"])
              ]))
            ])
          ])
        ]),
        _: 1
      });
    };
  }
};
const __unplugin_components_2 = /* @__PURE__ */ _export_sfc(_sfc_main$2, [["__scopeId", "data-v-ab1299ac"]]);
const _hoisted_1$1 = { class: "dropdown-container" };
const _hoisted_2 = { class: "dropdown-label" };
const _sfc_main$1 = {
  __name: "TriggerDialog",
  setup(__props) {
    const show = inject("show_trigger_editor");
    const plan_store = usePlanStore();
    const { sub_plan, backup_plans } = storeToRefs(plan_store);
    const triggerTimingOptions = [
      { label: "任务开始", value: "BEGINNING" },
      { label: "下班结束", value: "BEFORE_PLANNING" },
      { label: "上班结束", value: "AFTER_PLANNING" },
      { label: "任务结束", value: "END" }
    ];
    function update_trigger(data) {
      backup_plans.value[sub_plan.value].trigger = data;
    }
    return (_ctx, _cache) => {
      const _component_help_text = __unplugin_components_0$1;
      const _component_n_select = __unplugin_components_5;
      const _component_trigger_editor = __unplugin_components_2;
      const _component_n_scrollbar = Scrollbar;
      const _component_n_code = __unplugin_components_4;
      const _component_n_card = __unplugin_components_0$2;
      const _component_n_modal = __unplugin_components_4$1;
      return openBlock(), createBlock(_component_n_modal, {
        show: unref(show),
        "onUpdate:show": _cache[1] || (_cache[1] = ($event) => isRef(show) ? show.value = $event : null),
        preset: "card",
        title: "触发条件",
        "transform-origin": "center",
        style: { "width": "auto", "max-width": "90vw" }
      }, {
        default: withCtx(() => [
          createBaseVNode("div", _hoisted_1$1, [
            createBaseVNode("label", _hoisted_2, [
              _cache[3] || (_cache[3] = createTextVNode("触发时机 ")),
              createVNode(_component_help_text, null, {
                default: withCtx(() => _cache[2] || (_cache[2] = [
                  createBaseVNode("div", null, "任务开始：单个任务开始时", -1),
                  createBaseVNode("div", null, "下班结束：高效组下班任务安排完毕，生成上班时间任务前", -1),
                  createBaseVNode("div", null, "上班结束：高效组上班安排结束时", -1),
                  createBaseVNode("div", null, "任务结束：单个任务结束时", -1)
                ])),
                _: 1
              })
            ]),
            createVNode(_component_n_select, {
              value: unref(backup_plans)[unref(sub_plan)].trigger_timing,
              "onUpdate:value": _cache[0] || (_cache[0] = ($event) => unref(backup_plans)[unref(sub_plan)].trigger_timing = $event),
              options: triggerTimingOptions,
              placeholder: "Select Trigger Timing",
              class: "dropdown-select"
            }, null, 8, ["value"])
          ]),
          createVNode(_component_n_scrollbar, { style: { "max-height": "80vh", "margin-top": "5px" } }, {
            default: withCtx(() => [
              createVNode(_component_n_scrollbar, { "x-scrollable": "" }, {
                default: withCtx(() => [
                  createVNode(_component_trigger_editor, {
                    data: unref(backup_plans)[unref(sub_plan)].trigger,
                    onUpdate: update_trigger
                  }, null, 8, ["data"])
                ]),
                _: 1
              }),
              createVNode(_component_n_card, {
                style: { "margin-top": "8px" },
                "content-style": "padding: 8px",
                embedded: ""
              }, {
                default: withCtx(() => [
                  createVNode(_component_n_code, {
                    code: JSON.stringify(unref(backup_plans)[unref(sub_plan)].trigger, null, 2),
                    language: "json",
                    "word-wrap": ""
                  }, null, 8, ["code"])
                ]),
                _: 1
              })
            ]),
            _: 1
          })
        ]),
        _: 1
      }, 8, ["show"]);
    };
  }
};
function sleep(ms) {
  return new Promise((resolve) => setTimeout(resolve, ms));
}
function resolveUrl(url, baseUrl) {
  if (url.match(/^[a-z]+:\/\//i)) {
    return url;
  }
  if (url.match(/^\/\//)) {
    return window.location.protocol + url;
  }
  if (url.match(/^[a-z]+:/i)) {
    return url;
  }
  const doc = document.implementation.createHTMLDocument();
  const base = doc.createElement("base");
  const a = doc.createElement("a");
  doc.head.appendChild(base);
  doc.body.appendChild(a);
  if (baseUrl) {
    base.href = baseUrl;
  }
  a.href = url;
  return a.href;
}
const uuid = /* @__PURE__ */ (() => {
  let counter = 0;
  const random = () => (
    // eslint-disable-next-line no-bitwise
    `0000${(Math.random() * 36 ** 4 << 0).toString(36)}`.slice(-4)
  );
  return () => {
    counter += 1;
    return `u${random()}${counter}`;
  };
})();
function toArray(arrayLike) {
  const arr = [];
  for (let i = 0, l = arrayLike.length; i < l; i++) {
    arr.push(arrayLike[i]);
  }
  return arr;
}
function px(node, styleProperty) {
  const win = node.ownerDocument.defaultView || window;
  const val = win.getComputedStyle(node).getPropertyValue(styleProperty);
  return val ? parseFloat(val.replace("px", "")) : 0;
}
function getNodeWidth(node) {
  const leftBorder = px(node, "border-left-width");
  const rightBorder = px(node, "border-right-width");
  return node.clientWidth + leftBorder + rightBorder;
}
function getNodeHeight(node) {
  const topBorder = px(node, "border-top-width");
  const bottomBorder = px(node, "border-bottom-width");
  return node.clientHeight + topBorder + bottomBorder;
}
function getImageSize(targetNode, options = {}) {
  const width = options.width || getNodeWidth(targetNode);
  const height = options.height || getNodeHeight(targetNode);
  return { width, height };
}
function getPixelRatio() {
  let ratio;
  let FINAL_PROCESS;
  try {
    FINAL_PROCESS = process;
  } catch (e) {
  }
  const val = FINAL_PROCESS && FINAL_PROCESS.env ? FINAL_PROCESS.env.devicePixelRatio : null;
  if (val) {
    ratio = parseInt(val, 10);
    if (Number.isNaN(ratio)) {
      ratio = 1;
    }
  }
  return ratio || window.devicePixelRatio || 1;
}
const canvasDimensionLimit = 16384;
function checkCanvasDimensions(canvas) {
  if (canvas.width > canvasDimensionLimit || canvas.height > canvasDimensionLimit) {
    if (canvas.width > canvasDimensionLimit && canvas.height > canvasDimensionLimit) {
      if (canvas.width > canvas.height) {
        canvas.height *= canvasDimensionLimit / canvas.width;
        canvas.width = canvasDimensionLimit;
      } else {
        canvas.width *= canvasDimensionLimit / canvas.height;
        canvas.height = canvasDimensionLimit;
      }
    } else if (canvas.width > canvasDimensionLimit) {
      canvas.height *= canvasDimensionLimit / canvas.width;
      canvas.width = canvasDimensionLimit;
    } else {
      canvas.width *= canvasDimensionLimit / canvas.height;
      canvas.height = canvasDimensionLimit;
    }
  }
}
function canvasToBlob(canvas, options = {}) {
  if (canvas.toBlob) {
    return new Promise((resolve) => {
      canvas.toBlob(resolve, options.type ? options.type : "image/png", options.quality ? options.quality : 1);
    });
  }
  return new Promise((resolve) => {
    const binaryString = window.atob(canvas.toDataURL(options.type ? options.type : void 0, options.quality ? options.quality : void 0).split(",")[1]);
    const len = binaryString.length;
    const binaryArray = new Uint8Array(len);
    for (let i = 0; i < len; i += 1) {
      binaryArray[i] = binaryString.charCodeAt(i);
    }
    resolve(new Blob([binaryArray], {
      type: options.type ? options.type : "image/png"
    }));
  });
}
function createImage(url) {
  return new Promise((resolve, reject) => {
    const img = new Image();
    img.decode = () => resolve(img);
    img.onload = () => resolve(img);
    img.onerror = reject;
    img.crossOrigin = "anonymous";
    img.decoding = "async";
    img.src = url;
  });
}
async function svgToDataURL(svg) {
  return Promise.resolve().then(() => new XMLSerializer().serializeToString(svg)).then(encodeURIComponent).then((html) => `data:image/svg+xml;charset=utf-8,${html}`);
}
async function nodeToDataURL(node, width, height) {
  const xmlns = "http://www.w3.org/2000/svg";
  const svg = document.createElementNS(xmlns, "svg");
  const foreignObject = document.createElementNS(xmlns, "foreignObject");
  svg.setAttribute("width", `${width}`);
  svg.setAttribute("height", `${height}`);
  svg.setAttribute("viewBox", `0 0 ${width} ${height}`);
  foreignObject.setAttribute("width", "100%");
  foreignObject.setAttribute("height", "100%");
  foreignObject.setAttribute("x", "0");
  foreignObject.setAttribute("y", "0");
  foreignObject.setAttribute("externalResourcesRequired", "true");
  svg.appendChild(foreignObject);
  foreignObject.appendChild(node);
  return svgToDataURL(svg);
}
const isInstanceOfElement = (node, instance) => {
  if (node instanceof instance)
    return true;
  const nodePrototype = Object.getPrototypeOf(node);
  if (nodePrototype === null)
    return false;
  return nodePrototype.constructor.name === instance.name || isInstanceOfElement(nodePrototype, instance);
};
function formatCSSText(style2) {
  const content = style2.getPropertyValue("content");
  return `${style2.cssText} content: '${content.replace(/'|"/g, "")}';`;
}
function formatCSSProperties(style2) {
  return toArray(style2).map((name) => {
    const value = style2.getPropertyValue(name);
    const priority = style2.getPropertyPriority(name);
    return `${name}: ${value}${priority ? " !important" : ""};`;
  }).join(" ");
}
function getPseudoElementStyle(className, pseudo, style2) {
  const selector = `.${className}:${pseudo}`;
  const cssText = style2.cssText ? formatCSSText(style2) : formatCSSProperties(style2);
  return document.createTextNode(`${selector}{${cssText}}`);
}
function clonePseudoElement(nativeNode, clonedNode, pseudo) {
  const style2 = window.getComputedStyle(nativeNode, pseudo);
  const content = style2.getPropertyValue("content");
  if (content === "" || content === "none") {
    return;
  }
  const className = uuid();
  try {
    clonedNode.className = `${clonedNode.className} ${className}`;
  } catch (err) {
    return;
  }
  const styleElement = document.createElement("style");
  styleElement.appendChild(getPseudoElementStyle(className, pseudo, style2));
  clonedNode.appendChild(styleElement);
}
function clonePseudoElements(nativeNode, clonedNode) {
  clonePseudoElement(nativeNode, clonedNode, ":before");
  clonePseudoElement(nativeNode, clonedNode, ":after");
}
const WOFF = "application/font-woff";
const JPEG = "image/jpeg";
const mimes = {
  woff: WOFF,
  woff2: WOFF,
  ttf: "application/font-truetype",
  eot: "application/vnd.ms-fontobject",
  png: "image/png",
  jpg: JPEG,
  jpeg: JPEG,
  gif: "image/gif",
  tiff: "image/tiff",
  svg: "image/svg+xml",
  webp: "image/webp"
};
function getExtension(url) {
  const match = /\.([^./]*?)$/g.exec(url);
  return match ? match[1] : "";
}
function getMimeType(url) {
  const extension = getExtension(url).toLowerCase();
  return mimes[extension] || "";
}
function getContentFromDataUrl(dataURL) {
  return dataURL.split(/,/)[1];
}
function isDataUrl(url) {
  return url.search(/^(data:)/) !== -1;
}
function makeDataUrl(content, mimeType) {
  return `data:${mimeType};base64,${content}`;
}
async function fetchAsDataURL(url, init, process2) {
  const res = await fetch(url, init);
  if (res.status === 404) {
    throw new Error(`Resource "${res.url}" not found`);
  }
  const blob = await res.blob();
  return new Promise((resolve, reject) => {
    const reader = new FileReader();
    reader.onerror = reject;
    reader.onloadend = () => {
      try {
        resolve(process2({ res, result: reader.result }));
      } catch (error) {
        reject(error);
      }
    };
    reader.readAsDataURL(blob);
  });
}
const cache = {};
function getCacheKey(url, contentType, includeQueryParams) {
  let key = url.replace(/\?.*/, "");
  if (includeQueryParams) {
    key = url;
  }
  if (/ttf|otf|eot|woff2?/i.test(key)) {
    key = key.replace(/.*\//, "");
  }
  return contentType ? `[${contentType}]${key}` : key;
}
async function resourceToDataURL(resourceUrl, contentType, options) {
  const cacheKey = getCacheKey(resourceUrl, contentType, options.includeQueryParams);
  if (cache[cacheKey] != null) {
    return cache[cacheKey];
  }
  if (options.cacheBust) {
    resourceUrl += (/\?/.test(resourceUrl) ? "&" : "?") + (/* @__PURE__ */ new Date()).getTime();
  }
  let dataURL;
  try {
    const content = await fetchAsDataURL(resourceUrl, options.fetchRequestInit, ({ res, result }) => {
      if (!contentType) {
        contentType = res.headers.get("Content-Type") || "";
      }
      return getContentFromDataUrl(result);
    });
    dataURL = makeDataUrl(content, contentType);
  } catch (error) {
    dataURL = options.imagePlaceholder || "";
    let msg = `Failed to fetch resource: ${resourceUrl}`;
    if (error) {
      msg = typeof error === "string" ? error : error.message;
    }
    if (msg) {
      console.warn(msg);
    }
  }
  cache[cacheKey] = dataURL;
  return dataURL;
}
async function cloneCanvasElement(canvas) {
  const dataURL = canvas.toDataURL();
  if (dataURL === "data:,") {
    return canvas.cloneNode(false);
  }
  return createImage(dataURL);
}
async function cloneVideoElement(video, options) {
  if (video.currentSrc) {
    const canvas = document.createElement("canvas");
    const ctx = canvas.getContext("2d");
    canvas.width = video.clientWidth;
    canvas.height = video.clientHeight;
    ctx === null || ctx === void 0 ? void 0 : ctx.drawImage(video, 0, 0, canvas.width, canvas.height);
    const dataURL2 = canvas.toDataURL();
    return createImage(dataURL2);
  }
  const poster = video.poster;
  const contentType = getMimeType(poster);
  const dataURL = await resourceToDataURL(poster, contentType, options);
  return createImage(dataURL);
}
async function cloneIFrameElement(iframe) {
  var _a;
  try {
    if ((_a = iframe === null || iframe === void 0 ? void 0 : iframe.contentDocument) === null || _a === void 0 ? void 0 : _a.body) {
      return await cloneNode(iframe.contentDocument.body, {}, true);
    }
  } catch (_b) {
  }
  return iframe.cloneNode(false);
}
async function cloneSingleNode(node, options) {
  if (isInstanceOfElement(node, HTMLCanvasElement)) {
    return cloneCanvasElement(node);
  }
  if (isInstanceOfElement(node, HTMLVideoElement)) {
    return cloneVideoElement(node, options);
  }
  if (isInstanceOfElement(node, HTMLIFrameElement)) {
    return cloneIFrameElement(node);
  }
  return node.cloneNode(false);
}
const isSlotElement = (node) => node.tagName != null && node.tagName.toUpperCase() === "SLOT";
async function cloneChildren(nativeNode, clonedNode, options) {
  var _a, _b;
  let children = [];
  if (isSlotElement(nativeNode) && nativeNode.assignedNodes) {
    children = toArray(nativeNode.assignedNodes());
  } else if (isInstanceOfElement(nativeNode, HTMLIFrameElement) && ((_a = nativeNode.contentDocument) === null || _a === void 0 ? void 0 : _a.body)) {
    children = toArray(nativeNode.contentDocument.body.childNodes);
  } else {
    children = toArray(((_b = nativeNode.shadowRoot) !== null && _b !== void 0 ? _b : nativeNode).childNodes);
  }
  if (children.length === 0 || isInstanceOfElement(nativeNode, HTMLVideoElement)) {
    return clonedNode;
  }
  await children.reduce((deferred, child) => deferred.then(() => cloneNode(child, options)).then((clonedChild) => {
    if (clonedChild) {
      clonedNode.appendChild(clonedChild);
    }
  }), Promise.resolve());
  return clonedNode;
}
function cloneCSSStyle(nativeNode, clonedNode) {
  const targetStyle = clonedNode.style;
  if (!targetStyle) {
    return;
  }
  const sourceStyle = window.getComputedStyle(nativeNode);
  if (sourceStyle.cssText) {
    targetStyle.cssText = sourceStyle.cssText;
    targetStyle.transformOrigin = sourceStyle.transformOrigin;
  } else {
    toArray(sourceStyle).forEach((name) => {
      let value = sourceStyle.getPropertyValue(name);
      if (name === "font-size" && value.endsWith("px")) {
        const reducedFont = Math.floor(parseFloat(value.substring(0, value.length - 2))) - 0.1;
        value = `${reducedFont}px`;
      }
      if (isInstanceOfElement(nativeNode, HTMLIFrameElement) && name === "display" && value === "inline") {
        value = "block";
      }
      if (name === "d" && clonedNode.getAttribute("d")) {
        value = `path(${clonedNode.getAttribute("d")})`;
      }
      targetStyle.setProperty(name, value, sourceStyle.getPropertyPriority(name));
    });
  }
}
function cloneInputValue(nativeNode, clonedNode) {
  if (isInstanceOfElement(nativeNode, HTMLTextAreaElement)) {
    clonedNode.innerHTML = nativeNode.value;
  }
  if (isInstanceOfElement(nativeNode, HTMLInputElement)) {
    clonedNode.setAttribute("value", nativeNode.value);
  }
}
function cloneSelectValue(nativeNode, clonedNode) {
  if (isInstanceOfElement(nativeNode, HTMLSelectElement)) {
    const clonedSelect = clonedNode;
    const selectedOption = Array.from(clonedSelect.children).find((child) => nativeNode.value === child.getAttribute("value"));
    if (selectedOption) {
      selectedOption.setAttribute("selected", "");
    }
  }
}
function decorate(nativeNode, clonedNode) {
  if (isInstanceOfElement(clonedNode, Element)) {
    cloneCSSStyle(nativeNode, clonedNode);
    clonePseudoElements(nativeNode, clonedNode);
    cloneInputValue(nativeNode, clonedNode);
    cloneSelectValue(nativeNode, clonedNode);
  }
  return clonedNode;
}
async function ensureSVGSymbols(clone, options) {
  const uses = clone.querySelectorAll ? clone.querySelectorAll("use") : [];
  if (uses.length === 0) {
    return clone;
  }
  const processedDefs = {};
  for (let i = 0; i < uses.length; i++) {
    const use = uses[i];
    const id = use.getAttribute("xlink:href");
    if (id) {
      const exist = clone.querySelector(id);
      const definition = document.querySelector(id);
      if (!exist && definition && !processedDefs[id]) {
        processedDefs[id] = await cloneNode(definition, options, true);
      }
    }
  }
  const nodes = Object.values(processedDefs);
  if (nodes.length) {
    const ns = "http://www.w3.org/1999/xhtml";
    const svg = document.createElementNS(ns, "svg");
    svg.setAttribute("xmlns", ns);
    svg.style.position = "absolute";
    svg.style.width = "0";
    svg.style.height = "0";
    svg.style.overflow = "hidden";
    svg.style.display = "none";
    const defs = document.createElementNS(ns, "defs");
    svg.appendChild(defs);
    for (let i = 0; i < nodes.length; i++) {
      defs.appendChild(nodes[i]);
    }
    clone.appendChild(svg);
  }
  return clone;
}
async function cloneNode(node, options, isRoot) {
  if (!isRoot && options.filter && !options.filter(node)) {
    return null;
  }
  return Promise.resolve(node).then((clonedNode) => cloneSingleNode(clonedNode, options)).then((clonedNode) => cloneChildren(node, clonedNode, options)).then((clonedNode) => decorate(node, clonedNode)).then((clonedNode) => ensureSVGSymbols(clonedNode, options));
}
const URL_REGEX = /url\((['"]?)([^'"]+?)\1\)/g;
const URL_WITH_FORMAT_REGEX = /url\([^)]+\)\s*format\((["']?)([^"']+)\1\)/g;
const FONT_SRC_REGEX = /src:\s*(?:url\([^)]+\)\s*format\([^)]+\)[,;]\s*)+/g;
function toRegex(url) {
  const escaped = url.replace(/([.*+?^${}()|\[\]\/\\])/g, "\\$1");
  return new RegExp(`(url\\(['"]?)(${escaped})(['"]?\\))`, "g");
}
function parseURLs(cssText) {
  const urls = [];
  cssText.replace(URL_REGEX, (raw, quotation, url) => {
    urls.push(url);
    return raw;
  });
  return urls.filter((url) => !isDataUrl(url));
}
async function embed(cssText, resourceURL, baseURL, options, getContentFromUrl) {
  try {
    const resolvedURL = baseURL ? resolveUrl(resourceURL, baseURL) : resourceURL;
    const contentType = getMimeType(resourceURL);
    let dataURL;
    if (getContentFromUrl) ;
    else {
      dataURL = await resourceToDataURL(resolvedURL, contentType, options);
    }
    return cssText.replace(toRegex(resourceURL), `$1${dataURL}$3`);
  } catch (error) {
  }
  return cssText;
}
function filterPreferredFontFormat(str, { preferredFontFormat }) {
  return !preferredFontFormat ? str : str.replace(FONT_SRC_REGEX, (match) => {
    while (true) {
      const [src, , format] = URL_WITH_FORMAT_REGEX.exec(match) || [];
      if (!format) {
        return "";
      }
      if (format === preferredFontFormat) {
        return `src: ${src};`;
      }
    }
  });
}
function shouldEmbed(url) {
  return url.search(URL_REGEX) !== -1;
}
async function embedResources(cssText, baseUrl, options) {
  if (!shouldEmbed(cssText)) {
    return cssText;
  }
  const filteredCSSText = filterPreferredFontFormat(cssText, options);
  const urls = parseURLs(filteredCSSText);
  return urls.reduce((deferred, url) => deferred.then((css) => embed(css, url, baseUrl, options)), Promise.resolve(filteredCSSText));
}
async function embedProp(propName, node, options) {
  var _a;
  const propValue = (_a = node.style) === null || _a === void 0 ? void 0 : _a.getPropertyValue(propName);
  if (propValue) {
    const cssString = await embedResources(propValue, null, options);
    node.style.setProperty(propName, cssString, node.style.getPropertyPriority(propName));
    return true;
  }
  return false;
}
async function embedBackground(clonedNode, options) {
  if (!await embedProp("background", clonedNode, options)) {
    await embedProp("background-image", clonedNode, options);
  }
  if (!await embedProp("mask", clonedNode, options)) {
    await embedProp("mask-image", clonedNode, options);
  }
}
async function embedImageNode(clonedNode, options) {
  const isImageElement = isInstanceOfElement(clonedNode, HTMLImageElement);
  if (!(isImageElement && !isDataUrl(clonedNode.src)) && !(isInstanceOfElement(clonedNode, SVGImageElement) && !isDataUrl(clonedNode.href.baseVal))) {
    return;
  }
  const url = isImageElement ? clonedNode.src : clonedNode.href.baseVal;
  const dataURL = await resourceToDataURL(url, getMimeType(url), options);
  await new Promise((resolve, reject) => {
    clonedNode.onload = resolve;
    clonedNode.onerror = reject;
    const image = clonedNode;
    if (image.decode) {
      image.decode = resolve;
    }
    if (image.loading === "lazy") {
      image.loading = "eager";
    }
    if (isImageElement) {
      clonedNode.srcset = "";
      clonedNode.src = dataURL;
    } else {
      clonedNode.href.baseVal = dataURL;
    }
  });
}
async function embedChildren(clonedNode, options) {
  const children = toArray(clonedNode.childNodes);
  const deferreds = children.map((child) => embedImages(child, options));
  await Promise.all(deferreds).then(() => clonedNode);
}
async function embedImages(clonedNode, options) {
  if (isInstanceOfElement(clonedNode, Element)) {
    await embedBackground(clonedNode, options);
    await embedImageNode(clonedNode, options);
    await embedChildren(clonedNode, options);
  }
}
function applyStyle(node, options) {
  const { style: style2 } = node;
  if (options.backgroundColor) {
    style2.backgroundColor = options.backgroundColor;
  }
  if (options.width) {
    style2.width = `${options.width}px`;
  }
  if (options.height) {
    style2.height = `${options.height}px`;
  }
  const manual = options.style;
  if (manual != null) {
    Object.keys(manual).forEach((key) => {
      style2[key] = manual[key];
    });
  }
  return node;
}
const cssFetchCache = {};
async function fetchCSS(url) {
  let cache2 = cssFetchCache[url];
  if (cache2 != null) {
    return cache2;
  }
  const res = await fetch(url);
  const cssText = await res.text();
  cache2 = { url, cssText };
  cssFetchCache[url] = cache2;
  return cache2;
}
async function embedFonts(data, options) {
  let cssText = data.cssText;
  const regexUrl = /url\(["']?([^"')]+)["']?\)/g;
  const fontLocs = cssText.match(/url\([^)]+\)/g) || [];
  const loadFonts = fontLocs.map(async (loc) => {
    let url = loc.replace(regexUrl, "$1");
    if (!url.startsWith("https://")) {
      url = new URL(url, data.url).href;
    }
    return fetchAsDataURL(url, options.fetchRequestInit, ({ result }) => {
      cssText = cssText.replace(loc, `url(${result})`);
      return [loc, result];
    });
  });
  return Promise.all(loadFonts).then(() => cssText);
}
function parseCSS(source) {
  if (source == null) {
    return [];
  }
  const result = [];
  const commentsRegex = /(\/\*[\s\S]*?\*\/)/gi;
  let cssText = source.replace(commentsRegex, "");
  const keyframesRegex = new RegExp("((@.*?keyframes [\\s\\S]*?){([\\s\\S]*?}\\s*?)})", "gi");
  while (true) {
    const matches = keyframesRegex.exec(cssText);
    if (matches === null) {
      break;
    }
    result.push(matches[0]);
  }
  cssText = cssText.replace(keyframesRegex, "");
  const importRegex = /@import[\s\S]*?url\([^)]*\)[\s\S]*?;/gi;
  const combinedCSSRegex = "((\\s*?(?:\\/\\*[\\s\\S]*?\\*\\/)?\\s*?@media[\\s\\S]*?){([\\s\\S]*?)}\\s*?})|(([\\s\\S]*?){([\\s\\S]*?)})";
  const unifiedRegex = new RegExp(combinedCSSRegex, "gi");
  while (true) {
    let matches = importRegex.exec(cssText);
    if (matches === null) {
      matches = unifiedRegex.exec(cssText);
      if (matches === null) {
        break;
      } else {
        importRegex.lastIndex = unifiedRegex.lastIndex;
      }
    } else {
      unifiedRegex.lastIndex = importRegex.lastIndex;
    }
    result.push(matches[0]);
  }
  return result;
}
async function getCSSRules(styleSheets, options) {
  const ret = [];
  const deferreds = [];
  styleSheets.forEach((sheet) => {
    if ("cssRules" in sheet) {
      try {
        toArray(sheet.cssRules || []).forEach((item, index) => {
          if (item.type === CSSRule.IMPORT_RULE) {
            let importIndex = index + 1;
            const url = item.href;
            const deferred = fetchCSS(url).then((metadata) => embedFonts(metadata, options)).then((cssText) => parseCSS(cssText).forEach((rule) => {
              try {
                sheet.insertRule(rule, rule.startsWith("@import") ? importIndex += 1 : sheet.cssRules.length);
              } catch (error) {
                console.error("Error inserting rule from remote css", {
                  rule,
                  error
                });
              }
            })).catch((e) => {
              console.error("Error loading remote css", e.toString());
            });
            deferreds.push(deferred);
          }
        });
      } catch (e) {
        const inline = styleSheets.find((a) => a.href == null) || document.styleSheets[0];
        if (sheet.href != null) {
          deferreds.push(fetchCSS(sheet.href).then((metadata) => embedFonts(metadata, options)).then((cssText) => parseCSS(cssText).forEach((rule) => {
            inline.insertRule(rule, sheet.cssRules.length);
          })).catch((err) => {
            console.error("Error loading remote stylesheet", err);
          }));
        }
        console.error("Error inlining remote css file", e);
      }
    }
  });
  return Promise.all(deferreds).then(() => {
    styleSheets.forEach((sheet) => {
      if ("cssRules" in sheet) {
        try {
          toArray(sheet.cssRules || []).forEach((item) => {
            ret.push(item);
          });
        } catch (e) {
          console.error(`Error while reading CSS rules from ${sheet.href}`, e);
        }
      }
    });
    return ret;
  });
}
function getWebFontRules(cssRules) {
  return cssRules.filter((rule) => rule.type === CSSRule.FONT_FACE_RULE).filter((rule) => shouldEmbed(rule.style.getPropertyValue("src")));
}
async function parseWebFontRules(node, options) {
  if (node.ownerDocument == null) {
    throw new Error("Provided element is not within a Document");
  }
  const styleSheets = toArray(node.ownerDocument.styleSheets);
  const cssRules = await getCSSRules(styleSheets, options);
  return getWebFontRules(cssRules);
}
async function getWebFontCSS(node, options) {
  const rules = await parseWebFontRules(node, options);
  const cssTexts = await Promise.all(rules.map((rule) => {
    const baseUrl = rule.parentStyleSheet ? rule.parentStyleSheet.href : null;
    return embedResources(rule.cssText, baseUrl, options);
  }));
  return cssTexts.join("\n");
}
async function embedWebFonts(clonedNode, options) {
  const cssText = options.fontEmbedCSS != null ? options.fontEmbedCSS : options.skipFonts ? null : await getWebFontCSS(clonedNode, options);
  if (cssText) {
    const styleNode = document.createElement("style");
    const sytleContent = document.createTextNode(cssText);
    styleNode.appendChild(sytleContent);
    if (clonedNode.firstChild) {
      clonedNode.insertBefore(styleNode, clonedNode.firstChild);
    } else {
      clonedNode.appendChild(styleNode);
    }
  }
}
async function toSvg(node, options = {}) {
  const { width, height } = getImageSize(node, options);
  const clonedNode = await cloneNode(node, options, true);
  await embedWebFonts(clonedNode, options);
  await embedImages(clonedNode, options);
  applyStyle(clonedNode, options);
  const datauri = await nodeToDataURL(clonedNode, width, height);
  return datauri;
}
async function toCanvas(node, options = {}) {
  const { width, height } = getImageSize(node, options);
  const svg = await toSvg(node, options);
  const img = await createImage(svg);
  const canvas = document.createElement("canvas");
  const context = canvas.getContext("2d");
  const ratio = options.pixelRatio || getPixelRatio();
  const canvasWidth = options.canvasWidth || width;
  const canvasHeight = options.canvasHeight || height;
  canvas.width = canvasWidth * ratio;
  canvas.height = canvasHeight * ratio;
  if (!options.skipAutoScale) {
    checkCanvasDimensions(canvas);
  }
  canvas.style.width = `${canvasWidth}`;
  canvas.style.height = `${canvasHeight}`;
  if (options.backgroundColor) {
    context.fillStyle = options.backgroundColor;
    context.fillRect(0, 0, canvas.width, canvas.height);
  }
  context.drawImage(img, 0, 0, canvas.width, canvas.height);
  return canvas;
}
async function toBlob(node, options = {}) {
  const canvas = await toCanvas(node, options);
  const blob = await canvasToBlob(canvas);
  return blob;
}
const BROWSER_ALIASES_MAP = {
  "Amazon Silk": "amazon_silk",
  "Android Browser": "android",
  Bada: "bada",
  BlackBerry: "blackberry",
  Chrome: "chrome",
  Chromium: "chromium",
  Electron: "electron",
  Epiphany: "epiphany",
  Firefox: "firefox",
  Focus: "focus",
  Generic: "generic",
  "Google Search": "google_search",
  Googlebot: "googlebot",
  "Internet Explorer": "ie",
  "K-Meleon": "k_meleon",
  Maxthon: "maxthon",
  "Microsoft Edge": "edge",
  "MZ Browser": "mz",
  "NAVER Whale Browser": "naver",
  Opera: "opera",
  "Opera Coast": "opera_coast",
  PhantomJS: "phantomjs",
  Puffin: "puffin",
  QupZilla: "qupzilla",
  QQ: "qq",
  QQLite: "qqlite",
  Safari: "safari",
  Sailfish: "sailfish",
  "Samsung Internet for Android": "samsung_internet",
  SeaMonkey: "seamonkey",
  Sleipnir: "sleipnir",
  Swing: "swing",
  Tizen: "tizen",
  "UC Browser": "uc",
  Vivaldi: "vivaldi",
  "WebOS Browser": "webos",
  WeChat: "wechat",
  "Yandex Browser": "yandex",
  Roku: "roku"
};
const BROWSER_MAP = {
  amazon_silk: "Amazon Silk",
  android: "Android Browser",
  bada: "Bada",
  blackberry: "BlackBerry",
  chrome: "Chrome",
  chromium: "Chromium",
  electron: "Electron",
  epiphany: "Epiphany",
  firefox: "Firefox",
  focus: "Focus",
  generic: "Generic",
  googlebot: "Googlebot",
  google_search: "Google Search",
  ie: "Internet Explorer",
  k_meleon: "K-Meleon",
  maxthon: "Maxthon",
  edge: "Microsoft Edge",
  mz: "MZ Browser",
  naver: "NAVER Whale Browser",
  opera: "Opera",
  opera_coast: "Opera Coast",
  phantomjs: "PhantomJS",
  puffin: "Puffin",
  qupzilla: "QupZilla",
  qq: "QQ Browser",
  qqlite: "QQ Browser Lite",
  safari: "Safari",
  sailfish: "Sailfish",
  samsung_internet: "Samsung Internet for Android",
  seamonkey: "SeaMonkey",
  sleipnir: "Sleipnir",
  swing: "Swing",
  tizen: "Tizen",
  uc: "UC Browser",
  vivaldi: "Vivaldi",
  webos: "WebOS Browser",
  wechat: "WeChat",
  yandex: "Yandex Browser"
};
const PLATFORMS_MAP = {
  tablet: "tablet",
  mobile: "mobile",
  desktop: "desktop",
  tv: "tv"
};
const OS_MAP = {
  WindowsPhone: "Windows Phone",
  Windows: "Windows",
  MacOS: "macOS",
  iOS: "iOS",
  Android: "Android",
  WebOS: "WebOS",
  BlackBerry: "BlackBerry",
  Bada: "Bada",
  Tizen: "Tizen",
  Linux: "Linux",
  ChromeOS: "Chrome OS",
  PlayStation4: "PlayStation 4",
  Roku: "Roku"
};
const ENGINE_MAP = {
  EdgeHTML: "EdgeHTML",
  Blink: "Blink",
  Trident: "Trident",
  Presto: "Presto",
  Gecko: "Gecko",
  WebKit: "WebKit"
};
class Utils {
  /**
   * Get first matched item for a string
   * @param {RegExp} regexp
   * @param {String} ua
   * @return {Array|{index: number, input: string}|*|boolean|string}
   */
  static getFirstMatch(regexp, ua) {
    const match = ua.match(regexp);
    return match && match.length > 0 && match[1] || "";
  }
  /**
   * Get second matched item for a string
   * @param regexp
   * @param {String} ua
   * @return {Array|{index: number, input: string}|*|boolean|string}
   */
  static getSecondMatch(regexp, ua) {
    const match = ua.match(regexp);
    return match && match.length > 1 && match[2] || "";
  }
  /**
   * Match a regexp and return a constant or undefined
   * @param {RegExp} regexp
   * @param {String} ua
   * @param {*} _const Any const that will be returned if regexp matches the string
   * @return {*}
   */
  static matchAndReturnConst(regexp, ua, _const) {
    if (regexp.test(ua)) {
      return _const;
    }
    return void 0;
  }
  static getWindowsVersionName(version) {
    switch (version) {
      case "NT":
        return "NT";
      case "XP":
        return "XP";
      case "NT 5.0":
        return "2000";
      case "NT 5.1":
        return "XP";
      case "NT 5.2":
        return "2003";
      case "NT 6.0":
        return "Vista";
      case "NT 6.1":
        return "7";
      case "NT 6.2":
        return "8";
      case "NT 6.3":
        return "8.1";
      case "NT 10.0":
        return "10";
      default:
        return void 0;
    }
  }
  /**
   * Get macOS version name
   *    10.5 - Leopard
   *    10.6 - Snow Leopard
   *    10.7 - Lion
   *    10.8 - Mountain Lion
   *    10.9 - Mavericks
   *    10.10 - Yosemite
   *    10.11 - El Capitan
   *    10.12 - Sierra
   *    10.13 - High Sierra
   *    10.14 - Mojave
   *    10.15 - Catalina
   *
   * @example
   *   getMacOSVersionName("10.14") // 'Mojave'
   *
   * @param  {string} version
   * @return {string} versionName
   */
  static getMacOSVersionName(version) {
    const v = version.split(".").splice(0, 2).map((s) => parseInt(s, 10) || 0);
    v.push(0);
    if (v[0] !== 10) return void 0;
    switch (v[1]) {
      case 5:
        return "Leopard";
      case 6:
        return "Snow Leopard";
      case 7:
        return "Lion";
      case 8:
        return "Mountain Lion";
      case 9:
        return "Mavericks";
      case 10:
        return "Yosemite";
      case 11:
        return "El Capitan";
      case 12:
        return "Sierra";
      case 13:
        return "High Sierra";
      case 14:
        return "Mojave";
      case 15:
        return "Catalina";
      default:
        return void 0;
    }
  }
  /**
   * Get Android version name
   *    1.5 - Cupcake
   *    1.6 - Donut
   *    2.0 - Eclair
   *    2.1 - Eclair
   *    2.2 - Froyo
   *    2.x - Gingerbread
   *    3.x - Honeycomb
   *    4.0 - Ice Cream Sandwich
   *    4.1 - Jelly Bean
   *    4.4 - KitKat
   *    5.x - Lollipop
   *    6.x - Marshmallow
   *    7.x - Nougat
   *    8.x - Oreo
   *    9.x - Pie
   *
   * @example
   *   getAndroidVersionName("7.0") // 'Nougat'
   *
   * @param  {string} version
   * @return {string} versionName
   */
  static getAndroidVersionName(version) {
    const v = version.split(".").splice(0, 2).map((s) => parseInt(s, 10) || 0);
    v.push(0);
    if (v[0] === 1 && v[1] < 5) return void 0;
    if (v[0] === 1 && v[1] < 6) return "Cupcake";
    if (v[0] === 1 && v[1] >= 6) return "Donut";
    if (v[0] === 2 && v[1] < 2) return "Eclair";
    if (v[0] === 2 && v[1] === 2) return "Froyo";
    if (v[0] === 2 && v[1] > 2) return "Gingerbread";
    if (v[0] === 3) return "Honeycomb";
    if (v[0] === 4 && v[1] < 1) return "Ice Cream Sandwich";
    if (v[0] === 4 && v[1] < 4) return "Jelly Bean";
    if (v[0] === 4 && v[1] >= 4) return "KitKat";
    if (v[0] === 5) return "Lollipop";
    if (v[0] === 6) return "Marshmallow";
    if (v[0] === 7) return "Nougat";
    if (v[0] === 8) return "Oreo";
    if (v[0] === 9) return "Pie";
    return void 0;
  }
  /**
   * Get version precisions count
   *
   * @example
   *   getVersionPrecision("1.10.3") // 3
   *
   * @param  {string} version
   * @return {number}
   */
  static getVersionPrecision(version) {
    return version.split(".").length;
  }
  /**
   * Calculate browser version weight
   *
   * @example
   *   compareVersions('1.10.2.1',  '1.8.2.1.90')    // 1
   *   compareVersions('1.010.2.1', '1.09.2.1.90');  // 1
   *   compareVersions('1.10.2.1',  '1.10.2.1');     // 0
   *   compareVersions('1.10.2.1',  '1.0800.2');     // -1
   *   compareVersions('1.10.2.1',  '1.10',  true);  // 0
   *
   * @param {String} versionA versions versions to compare
   * @param {String} versionB versions versions to compare
   * @param {boolean} [isLoose] enable loose comparison
   * @return {Number} comparison result: -1 when versionA is lower,
   * 1 when versionA is bigger, 0 when both equal
   */
  /* eslint consistent-return: 1 */
  static compareVersions(versionA, versionB, isLoose = false) {
    const versionAPrecision = Utils.getVersionPrecision(versionA);
    const versionBPrecision = Utils.getVersionPrecision(versionB);
    let precision = Math.max(versionAPrecision, versionBPrecision);
    let lastPrecision = 0;
    const chunks = Utils.map([versionA, versionB], (version) => {
      const delta = precision - Utils.getVersionPrecision(version);
      const _version = version + new Array(delta + 1).join(".0");
      return Utils.map(_version.split("."), (chunk) => new Array(20 - chunk.length).join("0") + chunk).reverse();
    });
    if (isLoose) {
      lastPrecision = precision - Math.min(versionAPrecision, versionBPrecision);
    }
    precision -= 1;
    while (precision >= lastPrecision) {
      if (chunks[0][precision] > chunks[1][precision]) {
        return 1;
      }
      if (chunks[0][precision] === chunks[1][precision]) {
        if (precision === lastPrecision) {
          return 0;
        }
        precision -= 1;
      } else if (chunks[0][precision] < chunks[1][precision]) {
        return -1;
      }
    }
    return void 0;
  }
  /**
   * Array::map polyfill
   *
   * @param  {Array} arr
   * @param  {Function} iterator
   * @return {Array}
   */
  static map(arr, iterator) {
    const result = [];
    let i;
    if (Array.prototype.map) {
      return Array.prototype.map.call(arr, iterator);
    }
    for (i = 0; i < arr.length; i += 1) {
      result.push(iterator(arr[i]));
    }
    return result;
  }
  /**
   * Array::find polyfill
   *
   * @param  {Array} arr
   * @param  {Function} predicate
   * @return {Array}
   */
  static find(arr, predicate) {
    let i;
    let l;
    if (Array.prototype.find) {
      return Array.prototype.find.call(arr, predicate);
    }
    for (i = 0, l = arr.length; i < l; i += 1) {
      const value = arr[i];
      if (predicate(value, i)) {
        return value;
      }
    }
    return void 0;
  }
  /**
   * Object::assign polyfill
   *
   * @param  {Object} obj
   * @param  {Object} ...objs
   * @return {Object}
   */
  static assign(obj, ...assigners) {
    const result = obj;
    let i;
    let l;
    if (Object.assign) {
      return Object.assign(obj, ...assigners);
    }
    for (i = 0, l = assigners.length; i < l; i += 1) {
      const assigner = assigners[i];
      if (typeof assigner === "object" && assigner !== null) {
        const keys = Object.keys(assigner);
        keys.forEach((key) => {
          result[key] = assigner[key];
        });
      }
    }
    return obj;
  }
  /**
   * Get short version/alias for a browser name
   *
   * @example
   *   getBrowserAlias('Microsoft Edge') // edge
   *
   * @param  {string} browserName
   * @return {string}
   */
  static getBrowserAlias(browserName) {
    return BROWSER_ALIASES_MAP[browserName];
  }
  /**
   * Get short version/alias for a browser name
   *
   * @example
   *   getBrowserAlias('edge') // Microsoft Edge
   *
   * @param  {string} browserAlias
   * @return {string}
   */
  static getBrowserTypeByAlias(browserAlias) {
    return BROWSER_MAP[browserAlias] || "";
  }
}
const commonVersionIdentifier = /version\/(\d+(\.?_?\d+)+)/i;
const browsersList = [
  /* Googlebot */
  {
    test: [/googlebot/i],
    describe(ua) {
      const browser = {
        name: "Googlebot"
      };
      const version = Utils.getFirstMatch(/googlebot\/(\d+(\.\d+))/i, ua) || Utils.getFirstMatch(commonVersionIdentifier, ua);
      if (version) {
        browser.version = version;
      }
      return browser;
    }
  },
  /* Opera < 13.0 */
  {
    test: [/opera/i],
    describe(ua) {
      const browser = {
        name: "Opera"
      };
      const version = Utils.getFirstMatch(commonVersionIdentifier, ua) || Utils.getFirstMatch(/(?:opera)[\s/](\d+(\.?_?\d+)+)/i, ua);
      if (version) {
        browser.version = version;
      }
      return browser;
    }
  },
  /* Opera > 13.0 */
  {
    test: [/opr\/|opios/i],
    describe(ua) {
      const browser = {
        name: "Opera"
      };
      const version = Utils.getFirstMatch(/(?:opr|opios)[\s/](\S+)/i, ua) || Utils.getFirstMatch(commonVersionIdentifier, ua);
      if (version) {
        browser.version = version;
      }
      return browser;
    }
  },
  {
    test: [/SamsungBrowser/i],
    describe(ua) {
      const browser = {
        name: "Samsung Internet for Android"
      };
      const version = Utils.getFirstMatch(commonVersionIdentifier, ua) || Utils.getFirstMatch(/(?:SamsungBrowser)[\s/](\d+(\.?_?\d+)+)/i, ua);
      if (version) {
        browser.version = version;
      }
      return browser;
    }
  },
  {
    test: [/Whale/i],
    describe(ua) {
      const browser = {
        name: "NAVER Whale Browser"
      };
      const version = Utils.getFirstMatch(commonVersionIdentifier, ua) || Utils.getFirstMatch(/(?:whale)[\s/](\d+(?:\.\d+)+)/i, ua);
      if (version) {
        browser.version = version;
      }
      return browser;
    }
  },
  {
    test: [/MZBrowser/i],
    describe(ua) {
      const browser = {
        name: "MZ Browser"
      };
      const version = Utils.getFirstMatch(/(?:MZBrowser)[\s/](\d+(?:\.\d+)+)/i, ua) || Utils.getFirstMatch(commonVersionIdentifier, ua);
      if (version) {
        browser.version = version;
      }
      return browser;
    }
  },
  {
    test: [/focus/i],
    describe(ua) {
      const browser = {
        name: "Focus"
      };
      const version = Utils.getFirstMatch(/(?:focus)[\s/](\d+(?:\.\d+)+)/i, ua) || Utils.getFirstMatch(commonVersionIdentifier, ua);
      if (version) {
        browser.version = version;
      }
      return browser;
    }
  },
  {
    test: [/swing/i],
    describe(ua) {
      const browser = {
        name: "Swing"
      };
      const version = Utils.getFirstMatch(/(?:swing)[\s/](\d+(?:\.\d+)+)/i, ua) || Utils.getFirstMatch(commonVersionIdentifier, ua);
      if (version) {
        browser.version = version;
      }
      return browser;
    }
  },
  {
    test: [/coast/i],
    describe(ua) {
      const browser = {
        name: "Opera Coast"
      };
      const version = Utils.getFirstMatch(commonVersionIdentifier, ua) || Utils.getFirstMatch(/(?:coast)[\s/](\d+(\.?_?\d+)+)/i, ua);
      if (version) {
        browser.version = version;
      }
      return browser;
    }
  },
  {
    test: [/opt\/\d+(?:.?_?\d+)+/i],
    describe(ua) {
      const browser = {
        name: "Opera Touch"
      };
      const version = Utils.getFirstMatch(/(?:opt)[\s/](\d+(\.?_?\d+)+)/i, ua) || Utils.getFirstMatch(commonVersionIdentifier, ua);
      if (version) {
        browser.version = version;
      }
      return browser;
    }
  },
  {
    test: [/yabrowser/i],
    describe(ua) {
      const browser = {
        name: "Yandex Browser"
      };
      const version = Utils.getFirstMatch(/(?:yabrowser)[\s/](\d+(\.?_?\d+)+)/i, ua) || Utils.getFirstMatch(commonVersionIdentifier, ua);
      if (version) {
        browser.version = version;
      }
      return browser;
    }
  },
  {
    test: [/ucbrowser/i],
    describe(ua) {
      const browser = {
        name: "UC Browser"
      };
      const version = Utils.getFirstMatch(commonVersionIdentifier, ua) || Utils.getFirstMatch(/(?:ucbrowser)[\s/](\d+(\.?_?\d+)+)/i, ua);
      if (version) {
        browser.version = version;
      }
      return browser;
    }
  },
  {
    test: [/Maxthon|mxios/i],
    describe(ua) {
      const browser = {
        name: "Maxthon"
      };
      const version = Utils.getFirstMatch(commonVersionIdentifier, ua) || Utils.getFirstMatch(/(?:Maxthon|mxios)[\s/](\d+(\.?_?\d+)+)/i, ua);
      if (version) {
        browser.version = version;
      }
      return browser;
    }
  },
  {
    test: [/epiphany/i],
    describe(ua) {
      const browser = {
        name: "Epiphany"
      };
      const version = Utils.getFirstMatch(commonVersionIdentifier, ua) || Utils.getFirstMatch(/(?:epiphany)[\s/](\d+(\.?_?\d+)+)/i, ua);
      if (version) {
        browser.version = version;
      }
      return browser;
    }
  },
  {
    test: [/puffin/i],
    describe(ua) {
      const browser = {
        name: "Puffin"
      };
      const version = Utils.getFirstMatch(commonVersionIdentifier, ua) || Utils.getFirstMatch(/(?:puffin)[\s/](\d+(\.?_?\d+)+)/i, ua);
      if (version) {
        browser.version = version;
      }
      return browser;
    }
  },
  {
    test: [/sleipnir/i],
    describe(ua) {
      const browser = {
        name: "Sleipnir"
      };
      const version = Utils.getFirstMatch(commonVersionIdentifier, ua) || Utils.getFirstMatch(/(?:sleipnir)[\s/](\d+(\.?_?\d+)+)/i, ua);
      if (version) {
        browser.version = version;
      }
      return browser;
    }
  },
  {
    test: [/k-meleon/i],
    describe(ua) {
      const browser = {
        name: "K-Meleon"
      };
      const version = Utils.getFirstMatch(commonVersionIdentifier, ua) || Utils.getFirstMatch(/(?:k-meleon)[\s/](\d+(\.?_?\d+)+)/i, ua);
      if (version) {
        browser.version = version;
      }
      return browser;
    }
  },
  {
    test: [/micromessenger/i],
    describe(ua) {
      const browser = {
        name: "WeChat"
      };
      const version = Utils.getFirstMatch(/(?:micromessenger)[\s/](\d+(\.?_?\d+)+)/i, ua) || Utils.getFirstMatch(commonVersionIdentifier, ua);
      if (version) {
        browser.version = version;
      }
      return browser;
    }
  },
  {
    test: [/qqbrowser/i],
    describe(ua) {
      const browser = {
        name: /qqbrowserlite/i.test(ua) ? "QQ Browser Lite" : "QQ Browser"
      };
      const version = Utils.getFirstMatch(/(?:qqbrowserlite|qqbrowser)[/](\d+(\.?_?\d+)+)/i, ua) || Utils.getFirstMatch(commonVersionIdentifier, ua);
      if (version) {
        browser.version = version;
      }
      return browser;
    }
  },
  {
    test: [/msie|trident/i],
    describe(ua) {
      const browser = {
        name: "Internet Explorer"
      };
      const version = Utils.getFirstMatch(/(?:msie |rv:)(\d+(\.?_?\d+)+)/i, ua);
      if (version) {
        browser.version = version;
      }
      return browser;
    }
  },
  {
    test: [/\sedg\//i],
    describe(ua) {
      const browser = {
        name: "Microsoft Edge"
      };
      const version = Utils.getFirstMatch(/\sedg\/(\d+(\.?_?\d+)+)/i, ua);
      if (version) {
        browser.version = version;
      }
      return browser;
    }
  },
  {
    test: [/edg([ea]|ios)/i],
    describe(ua) {
      const browser = {
        name: "Microsoft Edge"
      };
      const version = Utils.getSecondMatch(/edg([ea]|ios)\/(\d+(\.?_?\d+)+)/i, ua);
      if (version) {
        browser.version = version;
      }
      return browser;
    }
  },
  {
    test: [/vivaldi/i],
    describe(ua) {
      const browser = {
        name: "Vivaldi"
      };
      const version = Utils.getFirstMatch(/vivaldi\/(\d+(\.?_?\d+)+)/i, ua);
      if (version) {
        browser.version = version;
      }
      return browser;
    }
  },
  {
    test: [/seamonkey/i],
    describe(ua) {
      const browser = {
        name: "SeaMonkey"
      };
      const version = Utils.getFirstMatch(/seamonkey\/(\d+(\.?_?\d+)+)/i, ua);
      if (version) {
        browser.version = version;
      }
      return browser;
    }
  },
  {
    test: [/sailfish/i],
    describe(ua) {
      const browser = {
        name: "Sailfish"
      };
      const version = Utils.getFirstMatch(/sailfish\s?browser\/(\d+(\.\d+)?)/i, ua);
      if (version) {
        browser.version = version;
      }
      return browser;
    }
  },
  {
    test: [/silk/i],
    describe(ua) {
      const browser = {
        name: "Amazon Silk"
      };
      const version = Utils.getFirstMatch(/silk\/(\d+(\.?_?\d+)+)/i, ua);
      if (version) {
        browser.version = version;
      }
      return browser;
    }
  },
  {
    test: [/phantom/i],
    describe(ua) {
      const browser = {
        name: "PhantomJS"
      };
      const version = Utils.getFirstMatch(/phantomjs\/(\d+(\.?_?\d+)+)/i, ua);
      if (version) {
        browser.version = version;
      }
      return browser;
    }
  },
  {
    test: [/slimerjs/i],
    describe(ua) {
      const browser = {
        name: "SlimerJS"
      };
      const version = Utils.getFirstMatch(/slimerjs\/(\d+(\.?_?\d+)+)/i, ua);
      if (version) {
        browser.version = version;
      }
      return browser;
    }
  },
  {
    test: [/blackberry|\bbb\d+/i, /rim\stablet/i],
    describe(ua) {
      const browser = {
        name: "BlackBerry"
      };
      const version = Utils.getFirstMatch(commonVersionIdentifier, ua) || Utils.getFirstMatch(/blackberry[\d]+\/(\d+(\.?_?\d+)+)/i, ua);
      if (version) {
        browser.version = version;
      }
      return browser;
    }
  },
  {
    test: [/(web|hpw)[o0]s/i],
    describe(ua) {
      const browser = {
        name: "WebOS Browser"
      };
      const version = Utils.getFirstMatch(commonVersionIdentifier, ua) || Utils.getFirstMatch(/w(?:eb)?[o0]sbrowser\/(\d+(\.?_?\d+)+)/i, ua);
      if (version) {
        browser.version = version;
      }
      return browser;
    }
  },
  {
    test: [/bada/i],
    describe(ua) {
      const browser = {
        name: "Bada"
      };
      const version = Utils.getFirstMatch(/dolfin\/(\d+(\.?_?\d+)+)/i, ua);
      if (version) {
        browser.version = version;
      }
      return browser;
    }
  },
  {
    test: [/tizen/i],
    describe(ua) {
      const browser = {
        name: "Tizen"
      };
      const version = Utils.getFirstMatch(/(?:tizen\s?)?browser\/(\d+(\.?_?\d+)+)/i, ua) || Utils.getFirstMatch(commonVersionIdentifier, ua);
      if (version) {
        browser.version = version;
      }
      return browser;
    }
  },
  {
    test: [/qupzilla/i],
    describe(ua) {
      const browser = {
        name: "QupZilla"
      };
      const version = Utils.getFirstMatch(/(?:qupzilla)[\s/](\d+(\.?_?\d+)+)/i, ua) || Utils.getFirstMatch(commonVersionIdentifier, ua);
      if (version) {
        browser.version = version;
      }
      return browser;
    }
  },
  {
    test: [/firefox|iceweasel|fxios/i],
    describe(ua) {
      const browser = {
        name: "Firefox"
      };
      const version = Utils.getFirstMatch(/(?:firefox|iceweasel|fxios)[\s/](\d+(\.?_?\d+)+)/i, ua);
      if (version) {
        browser.version = version;
      }
      return browser;
    }
  },
  {
    test: [/electron/i],
    describe(ua) {
      const browser = {
        name: "Electron"
      };
      const version = Utils.getFirstMatch(/(?:electron)\/(\d+(\.?_?\d+)+)/i, ua);
      if (version) {
        browser.version = version;
      }
      return browser;
    }
  },
  {
    test: [/MiuiBrowser/i],
    describe(ua) {
      const browser = {
        name: "Miui"
      };
      const version = Utils.getFirstMatch(/(?:MiuiBrowser)[\s/](\d+(\.?_?\d+)+)/i, ua);
      if (version) {
        browser.version = version;
      }
      return browser;
    }
  },
  {
    test: [/chromium/i],
    describe(ua) {
      const browser = {
        name: "Chromium"
      };
      const version = Utils.getFirstMatch(/(?:chromium)[\s/](\d+(\.?_?\d+)+)/i, ua) || Utils.getFirstMatch(commonVersionIdentifier, ua);
      if (version) {
        browser.version = version;
      }
      return browser;
    }
  },
  {
    test: [/chrome|crios|crmo/i],
    describe(ua) {
      const browser = {
        name: "Chrome"
      };
      const version = Utils.getFirstMatch(/(?:chrome|crios|crmo)\/(\d+(\.?_?\d+)+)/i, ua);
      if (version) {
        browser.version = version;
      }
      return browser;
    }
  },
  {
    test: [/GSA/i],
    describe(ua) {
      const browser = {
        name: "Google Search"
      };
      const version = Utils.getFirstMatch(/(?:GSA)\/(\d+(\.?_?\d+)+)/i, ua);
      if (version) {
        browser.version = version;
      }
      return browser;
    }
  },
  /* Android Browser */
  {
    test(parser) {
      const notLikeAndroid = !parser.test(/like android/i);
      const butAndroid = parser.test(/android/i);
      return notLikeAndroid && butAndroid;
    },
    describe(ua) {
      const browser = {
        name: "Android Browser"
      };
      const version = Utils.getFirstMatch(commonVersionIdentifier, ua);
      if (version) {
        browser.version = version;
      }
      return browser;
    }
  },
  /* PlayStation 4 */
  {
    test: [/playstation 4/i],
    describe(ua) {
      const browser = {
        name: "PlayStation 4"
      };
      const version = Utils.getFirstMatch(commonVersionIdentifier, ua);
      if (version) {
        browser.version = version;
      }
      return browser;
    }
  },
  /* Safari */
  {
    test: [/safari|applewebkit/i],
    describe(ua) {
      const browser = {
        name: "Safari"
      };
      const version = Utils.getFirstMatch(commonVersionIdentifier, ua);
      if (version) {
        browser.version = version;
      }
      return browser;
    }
  },
  /* Something else */
  {
    test: [/.*/i],
    describe(ua) {
      const regexpWithoutDeviceSpec = /^(.*)\/(.*) /;
      const regexpWithDeviceSpec = /^(.*)\/(.*)[ \t]\((.*)/;
      const hasDeviceSpec = ua.search("\\(") !== -1;
      const regexp = hasDeviceSpec ? regexpWithDeviceSpec : regexpWithoutDeviceSpec;
      return {
        name: Utils.getFirstMatch(regexp, ua),
        version: Utils.getSecondMatch(regexp, ua)
      };
    }
  }
];
const osParsersList = [
  /* Roku */
  {
    test: [/Roku\/DVP/],
    describe(ua) {
      const version = Utils.getFirstMatch(/Roku\/DVP-(\d+\.\d+)/i, ua);
      return {
        name: OS_MAP.Roku,
        version
      };
    }
  },
  /* Windows Phone */
  {
    test: [/windows phone/i],
    describe(ua) {
      const version = Utils.getFirstMatch(/windows phone (?:os)?\s?(\d+(\.\d+)*)/i, ua);
      return {
        name: OS_MAP.WindowsPhone,
        version
      };
    }
  },
  /* Windows */
  {
    test: [/windows /i],
    describe(ua) {
      const version = Utils.getFirstMatch(/Windows ((NT|XP)( \d\d?.\d)?)/i, ua);
      const versionName = Utils.getWindowsVersionName(version);
      return {
        name: OS_MAP.Windows,
        version,
        versionName
      };
    }
  },
  /* Firefox on iPad */
  {
    test: [/Macintosh(.*?) FxiOS(.*?)\//],
    describe(ua) {
      const result = {
        name: OS_MAP.iOS
      };
      const version = Utils.getSecondMatch(/(Version\/)(\d[\d.]+)/, ua);
      if (version) {
        result.version = version;
      }
      return result;
    }
  },
  /* macOS */
  {
    test: [/macintosh/i],
    describe(ua) {
      const version = Utils.getFirstMatch(/mac os x (\d+(\.?_?\d+)+)/i, ua).replace(/[_\s]/g, ".");
      const versionName = Utils.getMacOSVersionName(version);
      const os = {
        name: OS_MAP.MacOS,
        version
      };
      if (versionName) {
        os.versionName = versionName;
      }
      return os;
    }
  },
  /* iOS */
  {
    test: [/(ipod|iphone|ipad)/i],
    describe(ua) {
      const version = Utils.getFirstMatch(/os (\d+([_\s]\d+)*) like mac os x/i, ua).replace(/[_\s]/g, ".");
      return {
        name: OS_MAP.iOS,
        version
      };
    }
  },
  /* Android */
  {
    test(parser) {
      const notLikeAndroid = !parser.test(/like android/i);
      const butAndroid = parser.test(/android/i);
      return notLikeAndroid && butAndroid;
    },
    describe(ua) {
      const version = Utils.getFirstMatch(/android[\s/-](\d+(\.\d+)*)/i, ua);
      const versionName = Utils.getAndroidVersionName(version);
      const os = {
        name: OS_MAP.Android,
        version
      };
      if (versionName) {
        os.versionName = versionName;
      }
      return os;
    }
  },
  /* WebOS */
  {
    test: [/(web|hpw)[o0]s/i],
    describe(ua) {
      const version = Utils.getFirstMatch(/(?:web|hpw)[o0]s\/(\d+(\.\d+)*)/i, ua);
      const os = {
        name: OS_MAP.WebOS
      };
      if (version && version.length) {
        os.version = version;
      }
      return os;
    }
  },
  /* BlackBerry */
  {
    test: [/blackberry|\bbb\d+/i, /rim\stablet/i],
    describe(ua) {
      const version = Utils.getFirstMatch(/rim\stablet\sos\s(\d+(\.\d+)*)/i, ua) || Utils.getFirstMatch(/blackberry\d+\/(\d+([_\s]\d+)*)/i, ua) || Utils.getFirstMatch(/\bbb(\d+)/i, ua);
      return {
        name: OS_MAP.BlackBerry,
        version
      };
    }
  },
  /* Bada */
  {
    test: [/bada/i],
    describe(ua) {
      const version = Utils.getFirstMatch(/bada\/(\d+(\.\d+)*)/i, ua);
      return {
        name: OS_MAP.Bada,
        version
      };
    }
  },
  /* Tizen */
  {
    test: [/tizen/i],
    describe(ua) {
      const version = Utils.getFirstMatch(/tizen[/\s](\d+(\.\d+)*)/i, ua);
      return {
        name: OS_MAP.Tizen,
        version
      };
    }
  },
  /* Linux */
  {
    test: [/linux/i],
    describe() {
      return {
        name: OS_MAP.Linux
      };
    }
  },
  /* Chrome OS */
  {
    test: [/CrOS/],
    describe() {
      return {
        name: OS_MAP.ChromeOS
      };
    }
  },
  /* Playstation 4 */
  {
    test: [/PlayStation 4/],
    describe(ua) {
      const version = Utils.getFirstMatch(/PlayStation 4[/\s](\d+(\.\d+)*)/i, ua);
      return {
        name: OS_MAP.PlayStation4,
        version
      };
    }
  }
];
const platformParsersList = [
  /* Googlebot */
  {
    test: [/googlebot/i],
    describe() {
      return {
        type: "bot",
        vendor: "Google"
      };
    }
  },
  /* Huawei */
  {
    test: [/huawei/i],
    describe(ua) {
      const model = Utils.getFirstMatch(/(can-l01)/i, ua) && "Nova";
      const platform = {
        type: PLATFORMS_MAP.mobile,
        vendor: "Huawei"
      };
      if (model) {
        platform.model = model;
      }
      return platform;
    }
  },
  /* Nexus Tablet */
  {
    test: [/nexus\s*(?:7|8|9|10).*/i],
    describe() {
      return {
        type: PLATFORMS_MAP.tablet,
        vendor: "Nexus"
      };
    }
  },
  /* iPad */
  {
    test: [/ipad/i],
    describe() {
      return {
        type: PLATFORMS_MAP.tablet,
        vendor: "Apple",
        model: "iPad"
      };
    }
  },
  /* Firefox on iPad */
  {
    test: [/Macintosh(.*?) FxiOS(.*?)\//],
    describe() {
      return {
        type: PLATFORMS_MAP.tablet,
        vendor: "Apple",
        model: "iPad"
      };
    }
  },
  /* Amazon Kindle Fire */
  {
    test: [/kftt build/i],
    describe() {
      return {
        type: PLATFORMS_MAP.tablet,
        vendor: "Amazon",
        model: "Kindle Fire HD 7"
      };
    }
  },
  /* Another Amazon Tablet with Silk */
  {
    test: [/silk/i],
    describe() {
      return {
        type: PLATFORMS_MAP.tablet,
        vendor: "Amazon"
      };
    }
  },
  /* Tablet */
  {
    test: [/tablet(?! pc)/i],
    describe() {
      return {
        type: PLATFORMS_MAP.tablet
      };
    }
  },
  /* iPod/iPhone */
  {
    test(parser) {
      const iDevice = parser.test(/ipod|iphone/i);
      const likeIDevice = parser.test(/like (ipod|iphone)/i);
      return iDevice && !likeIDevice;
    },
    describe(ua) {
      const model = Utils.getFirstMatch(/(ipod|iphone)/i, ua);
      return {
        type: PLATFORMS_MAP.mobile,
        vendor: "Apple",
        model
      };
    }
  },
  /* Nexus Mobile */
  {
    test: [/nexus\s*[0-6].*/i, /galaxy nexus/i],
    describe() {
      return {
        type: PLATFORMS_MAP.mobile,
        vendor: "Nexus"
      };
    }
  },
  /* Mobile */
  {
    test: [/[^-]mobi/i],
    describe() {
      return {
        type: PLATFORMS_MAP.mobile
      };
    }
  },
  /* BlackBerry */
  {
    test(parser) {
      return parser.getBrowserName(true) === "blackberry";
    },
    describe() {
      return {
        type: PLATFORMS_MAP.mobile,
        vendor: "BlackBerry"
      };
    }
  },
  /* Bada */
  {
    test(parser) {
      return parser.getBrowserName(true) === "bada";
    },
    describe() {
      return {
        type: PLATFORMS_MAP.mobile
      };
    }
  },
  /* Windows Phone */
  {
    test(parser) {
      return parser.getBrowserName() === "windows phone";
    },
    describe() {
      return {
        type: PLATFORMS_MAP.mobile,
        vendor: "Microsoft"
      };
    }
  },
  /* Android Tablet */
  {
    test(parser) {
      const osMajorVersion = Number(String(parser.getOSVersion()).split(".")[0]);
      return parser.getOSName(true) === "android" && osMajorVersion >= 3;
    },
    describe() {
      return {
        type: PLATFORMS_MAP.tablet
      };
    }
  },
  /* Android Mobile */
  {
    test(parser) {
      return parser.getOSName(true) === "android";
    },
    describe() {
      return {
        type: PLATFORMS_MAP.mobile
      };
    }
  },
  /* desktop */
  {
    test(parser) {
      return parser.getOSName(true) === "macos";
    },
    describe() {
      return {
        type: PLATFORMS_MAP.desktop,
        vendor: "Apple"
      };
    }
  },
  /* Windows */
  {
    test(parser) {
      return parser.getOSName(true) === "windows";
    },
    describe() {
      return {
        type: PLATFORMS_MAP.desktop
      };
    }
  },
  /* Linux */
  {
    test(parser) {
      return parser.getOSName(true) === "linux";
    },
    describe() {
      return {
        type: PLATFORMS_MAP.desktop
      };
    }
  },
  /* PlayStation 4 */
  {
    test(parser) {
      return parser.getOSName(true) === "playstation 4";
    },
    describe() {
      return {
        type: PLATFORMS_MAP.tv
      };
    }
  },
  /* Roku */
  {
    test(parser) {
      return parser.getOSName(true) === "roku";
    },
    describe() {
      return {
        type: PLATFORMS_MAP.tv
      };
    }
  }
];
const enginesParsersList = [
  /* EdgeHTML */
  {
    test(parser) {
      return parser.getBrowserName(true) === "microsoft edge";
    },
    describe(ua) {
      const isBlinkBased = /\sedg\//i.test(ua);
      if (isBlinkBased) {
        return {
          name: ENGINE_MAP.Blink
        };
      }
      const version = Utils.getFirstMatch(/edge\/(\d+(\.?_?\d+)+)/i, ua);
      return {
        name: ENGINE_MAP.EdgeHTML,
        version
      };
    }
  },
  /* Trident */
  {
    test: [/trident/i],
    describe(ua) {
      const engine = {
        name: ENGINE_MAP.Trident
      };
      const version = Utils.getFirstMatch(/trident\/(\d+(\.?_?\d+)+)/i, ua);
      if (version) {
        engine.version = version;
      }
      return engine;
    }
  },
  /* Presto */
  {
    test(parser) {
      return parser.test(/presto/i);
    },
    describe(ua) {
      const engine = {
        name: ENGINE_MAP.Presto
      };
      const version = Utils.getFirstMatch(/presto\/(\d+(\.?_?\d+)+)/i, ua);
      if (version) {
        engine.version = version;
      }
      return engine;
    }
  },
  /* Gecko */
  {
    test(parser) {
      const isGecko = parser.test(/gecko/i);
      const likeGecko = parser.test(/like gecko/i);
      return isGecko && !likeGecko;
    },
    describe(ua) {
      const engine = {
        name: ENGINE_MAP.Gecko
      };
      const version = Utils.getFirstMatch(/gecko\/(\d+(\.?_?\d+)+)/i, ua);
      if (version) {
        engine.version = version;
      }
      return engine;
    }
  },
  /* Blink */
  {
    test: [/(apple)?webkit\/537\.36/i],
    describe() {
      return {
        name: ENGINE_MAP.Blink
      };
    }
  },
  /* WebKit */
  {
    test: [/(apple)?webkit/i],
    describe(ua) {
      const engine = {
        name: ENGINE_MAP.WebKit
      };
      const version = Utils.getFirstMatch(/webkit\/(\d+(\.?_?\d+)+)/i, ua);
      if (version) {
        engine.version = version;
      }
      return engine;
    }
  }
];
class Parser {
  /**
   * Create instance of Parser
   *
   * @param {String} UA User-Agent string
   * @param {Boolean} [skipParsing=false] parser can skip parsing in purpose of performance
   * improvements if you need to make a more particular parsing
   * like {@link Parser#parseBrowser} or {@link Parser#parsePlatform}
   *
   * @throw {Error} in case of empty UA String
   *
   * @constructor
   */
  constructor(UA, skipParsing = false) {
    if (UA === void 0 || UA === null || UA === "") {
      throw new Error("UserAgent parameter can't be empty");
    }
    this._ua = UA;
    this.parsedResult = {};
    if (skipParsing !== true) {
      this.parse();
    }
  }
  /**
   * Get UserAgent string of current Parser instance
   * @return {String} User-Agent String of the current <Parser> object
   *
   * @public
   */
  getUA() {
    return this._ua;
  }
  /**
   * Test a UA string for a regexp
   * @param {RegExp} regex
   * @return {Boolean}
   */
  test(regex) {
    return regex.test(this._ua);
  }
  /**
   * Get parsed browser object
   * @return {Object}
   */
  parseBrowser() {
    this.parsedResult.browser = {};
    const browserDescriptor = Utils.find(browsersList, (_browser) => {
      if (typeof _browser.test === "function") {
        return _browser.test(this);
      }
      if (_browser.test instanceof Array) {
        return _browser.test.some((condition) => this.test(condition));
      }
      throw new Error("Browser's test function is not valid");
    });
    if (browserDescriptor) {
      this.parsedResult.browser = browserDescriptor.describe(this.getUA());
    }
    return this.parsedResult.browser;
  }
  /**
   * Get parsed browser object
   * @return {Object}
   *
   * @public
   */
  getBrowser() {
    if (this.parsedResult.browser) {
      return this.parsedResult.browser;
    }
    return this.parseBrowser();
  }
  /**
   * Get browser's name
   * @return {String} Browser's name or an empty string
   *
   * @public
   */
  getBrowserName(toLowerCase) {
    if (toLowerCase) {
      return String(this.getBrowser().name).toLowerCase() || "";
    }
    return this.getBrowser().name || "";
  }
  /**
   * Get browser's version
   * @return {String} version of browser
   *
   * @public
   */
  getBrowserVersion() {
    return this.getBrowser().version;
  }
  /**
   * Get OS
   * @return {Object}
   *
   * @example
   * this.getOS();
   * {
   *   name: 'macOS',
   *   version: '10.11.12'
   * }
   */
  getOS() {
    if (this.parsedResult.os) {
      return this.parsedResult.os;
    }
    return this.parseOS();
  }
  /**
   * Parse OS and save it to this.parsedResult.os
   * @return {*|{}}
   */
  parseOS() {
    this.parsedResult.os = {};
    const os = Utils.find(osParsersList, (_os) => {
      if (typeof _os.test === "function") {
        return _os.test(this);
      }
      if (_os.test instanceof Array) {
        return _os.test.some((condition) => this.test(condition));
      }
      throw new Error("Browser's test function is not valid");
    });
    if (os) {
      this.parsedResult.os = os.describe(this.getUA());
    }
    return this.parsedResult.os;
  }
  /**
   * Get OS name
   * @param {Boolean} [toLowerCase] return lower-cased value
   * @return {String} name of the OS — macOS, Windows, Linux, etc.
   */
  getOSName(toLowerCase) {
    const { name } = this.getOS();
    if (toLowerCase) {
      return String(name).toLowerCase() || "";
    }
    return name || "";
  }
  /**
   * Get OS version
   * @return {String} full version with dots ('10.11.12', '5.6', etc)
   */
  getOSVersion() {
    return this.getOS().version;
  }
  /**
   * Get parsed platform
   * @return {{}}
   */
  getPlatform() {
    if (this.parsedResult.platform) {
      return this.parsedResult.platform;
    }
    return this.parsePlatform();
  }
  /**
   * Get platform name
   * @param {Boolean} [toLowerCase=false]
   * @return {*}
   */
  getPlatformType(toLowerCase = false) {
    const { type } = this.getPlatform();
    if (toLowerCase) {
      return String(type).toLowerCase() || "";
    }
    return type || "";
  }
  /**
   * Get parsed platform
   * @return {{}}
   */
  parsePlatform() {
    this.parsedResult.platform = {};
    const platform = Utils.find(platformParsersList, (_platform) => {
      if (typeof _platform.test === "function") {
        return _platform.test(this);
      }
      if (_platform.test instanceof Array) {
        return _platform.test.some((condition) => this.test(condition));
      }
      throw new Error("Browser's test function is not valid");
    });
    if (platform) {
      this.parsedResult.platform = platform.describe(this.getUA());
    }
    return this.parsedResult.platform;
  }
  /**
   * Get parsed engine
   * @return {{}}
   */
  getEngine() {
    if (this.parsedResult.engine) {
      return this.parsedResult.engine;
    }
    return this.parseEngine();
  }
  /**
   * Get engines's name
   * @return {String} Engines's name or an empty string
   *
   * @public
   */
  getEngineName(toLowerCase) {
    if (toLowerCase) {
      return String(this.getEngine().name).toLowerCase() || "";
    }
    return this.getEngine().name || "";
  }
  /**
   * Get parsed platform
   * @return {{}}
   */
  parseEngine() {
    this.parsedResult.engine = {};
    const engine = Utils.find(enginesParsersList, (_engine) => {
      if (typeof _engine.test === "function") {
        return _engine.test(this);
      }
      if (_engine.test instanceof Array) {
        return _engine.test.some((condition) => this.test(condition));
      }
      throw new Error("Browser's test function is not valid");
    });
    if (engine) {
      this.parsedResult.engine = engine.describe(this.getUA());
    }
    return this.parsedResult.engine;
  }
  /**
   * Parse full information about the browser
   * @returns {Parser}
   */
  parse() {
    this.parseBrowser();
    this.parseOS();
    this.parsePlatform();
    this.parseEngine();
    return this;
  }
  /**
   * Get parsed result
   * @return {ParsedResult}
   */
  getResult() {
    return Utils.assign({}, this.parsedResult);
  }
  /**
   * Check if parsed browser matches certain conditions
   *
   * @param {Object} checkTree It's one or two layered object,
   * which can include a platform or an OS on the first layer
   * and should have browsers specs on the bottom-laying layer
   *
   * @returns {Boolean|undefined} Whether the browser satisfies the set conditions or not.
   * Returns `undefined` when the browser is no described in the checkTree object.
   *
   * @example
   * const browser = Bowser.getParser(window.navigator.userAgent);
   * if (browser.satisfies({chrome: '>118.01.1322' }))
   * // or with os
   * if (browser.satisfies({windows: { chrome: '>118.01.1322' } }))
   * // or with platforms
   * if (browser.satisfies({desktop: { chrome: '>118.01.1322' } }))
   */
  satisfies(checkTree) {
    const platformsAndOSes = {};
    let platformsAndOSCounter = 0;
    const browsers = {};
    let browsersCounter = 0;
    const allDefinitions = Object.keys(checkTree);
    allDefinitions.forEach((key) => {
      const currentDefinition = checkTree[key];
      if (typeof currentDefinition === "string") {
        browsers[key] = currentDefinition;
        browsersCounter += 1;
      } else if (typeof currentDefinition === "object") {
        platformsAndOSes[key] = currentDefinition;
        platformsAndOSCounter += 1;
      }
    });
    if (platformsAndOSCounter > 0) {
      const platformsAndOSNames = Object.keys(platformsAndOSes);
      const OSMatchingDefinition = Utils.find(platformsAndOSNames, (name) => this.isOS(name));
      if (OSMatchingDefinition) {
        const osResult = this.satisfies(platformsAndOSes[OSMatchingDefinition]);
        if (osResult !== void 0) {
          return osResult;
        }
      }
      const platformMatchingDefinition = Utils.find(
        platformsAndOSNames,
        (name) => this.isPlatform(name)
      );
      if (platformMatchingDefinition) {
        const platformResult = this.satisfies(platformsAndOSes[platformMatchingDefinition]);
        if (platformResult !== void 0) {
          return platformResult;
        }
      }
    }
    if (browsersCounter > 0) {
      const browserNames = Object.keys(browsers);
      const matchingDefinition = Utils.find(browserNames, (name) => this.isBrowser(name, true));
      if (matchingDefinition !== void 0) {
        return this.compareVersion(browsers[matchingDefinition]);
      }
    }
    return void 0;
  }
  /**
   * Check if the browser name equals the passed string
   * @param browserName The string to compare with the browser name
   * @param [includingAlias=false] The flag showing whether alias will be included into comparison
   * @returns {boolean}
   */
  isBrowser(browserName, includingAlias = false) {
    const defaultBrowserName = this.getBrowserName().toLowerCase();
    let browserNameLower = browserName.toLowerCase();
    const alias = Utils.getBrowserTypeByAlias(browserNameLower);
    if (includingAlias && alias) {
      browserNameLower = alias.toLowerCase();
    }
    return browserNameLower === defaultBrowserName;
  }
  compareVersion(version) {
    let expectedResults = [0];
    let comparableVersion = version;
    let isLoose = false;
    const currentBrowserVersion = this.getBrowserVersion();
    if (typeof currentBrowserVersion !== "string") {
      return void 0;
    }
    if (version[0] === ">" || version[0] === "<") {
      comparableVersion = version.substr(1);
      if (version[1] === "=") {
        isLoose = true;
        comparableVersion = version.substr(2);
      } else {
        expectedResults = [];
      }
      if (version[0] === ">") {
        expectedResults.push(1);
      } else {
        expectedResults.push(-1);
      }
    } else if (version[0] === "=") {
      comparableVersion = version.substr(1);
    } else if (version[0] === "~") {
      isLoose = true;
      comparableVersion = version.substr(1);
    }
    return expectedResults.indexOf(
      Utils.compareVersions(currentBrowserVersion, comparableVersion, isLoose)
    ) > -1;
  }
  isOS(osName) {
    return this.getOSName(true) === String(osName).toLowerCase();
  }
  isPlatform(platformType) {
    return this.getPlatformType(true) === String(platformType).toLowerCase();
  }
  isEngine(engineName) {
    return this.getEngineName(true) === String(engineName).toLowerCase();
  }
  /**
   * Is anything? Check if the browser is called "anything",
   * the OS called "anything" or the platform called "anything"
   * @param {String} anything
   * @param [includingAlias=false] The flag showing whether alias will be included into comparison
   * @returns {Boolean}
   */
  is(anything, includingAlias = false) {
    return this.isBrowser(anything, includingAlias) || this.isOS(anything) || this.isPlatform(anything);
  }
  /**
   * Check if any of the given values satisfies this.is(anything)
   * @param {String[]} anythings
   * @returns {Boolean}
   */
  some(anythings = []) {
    return anythings.some((anything) => this.is(anything));
  }
}
/*!
 * Bowser - a browser detector
 * https://github.com/lancedikson/bowser
 * MIT License | (c) Dustin Diaz 2012-2015
 * MIT License | (c) Denis Demchenko 2015-2019
 */
class Bowser {
  /**
   * Creates a {@link Parser} instance
   *
   * @param {String} UA UserAgent string
   * @param {Boolean} [skipParsing=false] Will make the Parser postpone parsing until you ask it
   * explicitly. Same as `skipParsing` for {@link Parser}.
   * @returns {Parser}
   * @throws {Error} when UA is not a String
   *
   * @example
   * const parser = Bowser.getParser(window.navigator.userAgent);
   * const result = parser.getResult();
   */
  static getParser(UA, skipParsing = false) {
    if (typeof UA !== "string") {
      throw new Error("UserAgent should be a string");
    }
    return new Parser(UA, skipParsing);
  }
  /**
   * Creates a {@link Parser} instance and runs {@link Parser.getResult} immediately
   *
   * @param UA
   * @return {ParsedResult}
   *
   * @example
   * const result = Bowser.parse(window.navigator.userAgent);
   */
  static parse(UA) {
    return new Parser(UA).getResult();
  }
  static get BROWSER_MAP() {
    return BROWSER_MAP;
  }
  static get ENGINE_MAP() {
    return ENGINE_MAP;
  }
  static get OS_MAP() {
    return OS_MAP;
  }
  static get PLATFORMS_MAP() {
    return PLATFORMS_MAP;
  }
}
var DocumentExport$1 = {};
var hasRequiredDocumentExport;
function requireDocumentExport() {
  if (hasRequiredDocumentExport) return DocumentExport$1;
  hasRequiredDocumentExport = 1;
  Object.defineProperty(DocumentExport$1, "__esModule", { value: true });
  const vue_1 = requireVue();
  const _hoisted_110 = {
    xmlns: "http://www.w3.org/2000/svg",
    "xmlns:xlink": "http://www.w3.org/1999/xlink",
    viewBox: "0 0 32 32"
  };
  DocumentExport$1.default = (0, vue_1.defineComponent)({
    name: "DocumentExport",
    render: function render(_ctx, _cache) {
      return (0, vue_1.openBlock)(), (0, vue_1.createElementBlock)(
        "svg",
        _hoisted_110,
        _cache[0] || (_cache[0] = [
          (0, vue_1.createElementVNode)(
            "path",
            {
              d: "M13 21h13.17l-2.58 2.59L25 25l5-5l-5-5l-1.41 1.41L26.17 19H13v2z",
              fill: "currentColor"
            },
            null,
            -1
            /* HOISTED */
          ),
          (0, vue_1.createElementVNode)(
            "path",
            {
              d: "M22 14v-4a1 1 0 0 0-.29-.71l-7-7A1 1 0 0 0 14 2H4a2 2 0 0 0-2 2v24a2 2 0 0 0 2 2h16a2 2 0 0 0 2-2v-2h-2v2H4V4h8v6a2 2 0 0 0 2 2h6v2zm-8-4V4.41L19.59 10z",
              fill: "currentColor"
            },
            null,
            -1
            /* HOISTED */
          )
        ])
      );
    }
  });
  return DocumentExport$1;
}
var DocumentExportExports = /* @__PURE__ */ requireDocumentExport();
const DocumentExport = /* @__PURE__ */ getDefaultExportFromCjs(DocumentExportExports);
var DocumentImport$1 = {};
var hasRequiredDocumentImport;
function requireDocumentImport() {
  if (hasRequiredDocumentImport) return DocumentImport$1;
  hasRequiredDocumentImport = 1;
  Object.defineProperty(DocumentImport$1, "__esModule", { value: true });
  const vue_1 = requireVue();
  const _hoisted_110 = {
    xmlns: "http://www.w3.org/2000/svg",
    "xmlns:xlink": "http://www.w3.org/1999/xlink",
    viewBox: "0 0 32 32"
  };
  DocumentImport$1.default = (0, vue_1.defineComponent)({
    name: "DocumentImport",
    render: function render(_ctx, _cache) {
      return (0, vue_1.openBlock)(), (0, vue_1.createElementBlock)(
        "svg",
        _hoisted_110,
        _cache[0] || (_cache[0] = [
          (0, vue_1.createElementVNode)(
            "path",
            {
              d: "M28 19H14.83l2.58-2.59L16 15l-5 5l5 5l1.41-1.41L14.83 21H28v-2z",
              fill: "currentColor"
            },
            null,
            -1
            /* HOISTED */
          ),
          (0, vue_1.createElementVNode)(
            "path",
            {
              d: "M24 14v-4a1 1 0 0 0-.29-.71l-7-7A1 1 0 0 0 16 2H6a2 2 0 0 0-2 2v24a2 2 0 0 0 2 2h16a2 2 0 0 0 2-2v-2h-2v2H6V4h8v6a2 2 0 0 0 2 2h6v2zm-8-4V4.41L21.59 10z",
              fill: "currentColor"
            },
            null,
            -1
            /* HOISTED */
          )
        ])
      );
    }
  });
  return DocumentImport$1;
}
var DocumentImportExports = /* @__PURE__ */ requireDocumentImport();
const DocumentImport = /* @__PURE__ */ getDefaultExportFromCjs(DocumentImportExports);
var CodeSlash$1 = {};
var hasRequiredCodeSlash;
function requireCodeSlash() {
  if (hasRequiredCodeSlash) return CodeSlash$1;
  hasRequiredCodeSlash = 1;
  Object.defineProperty(CodeSlash$1, "__esModule", { value: true });
  const vue_1 = requireVue();
  const _hoisted_110 = {
    xmlns: "http://www.w3.org/2000/svg",
    "xmlns:xlink": "http://www.w3.org/1999/xlink",
    viewBox: "0 0 512 512"
  };
  CodeSlash$1.default = (0, vue_1.defineComponent)({
    name: "CodeSlash",
    render: function render(_ctx, _cache) {
      return (0, vue_1.openBlock)(), (0, vue_1.createElementBlock)(
        "svg",
        _hoisted_110,
        _cache[0] || (_cache[0] = [
          (0, vue_1.createElementVNode)(
            "path",
            {
              d: "M160 389a20.91 20.91 0 0 1-13.82-5.2l-128-112a21 21 0 0 1 0-31.6l128-112a21 21 0 0 1 27.66 31.61L63.89 256l109.94 96.19A21 21 0 0 1 160 389z",
              fill: "currentColor"
            },
            null,
            -1
            /* HOISTED */
          ),
          (0, vue_1.createElementVNode)(
            "path",
            {
              d: "M352 389a21 21 0 0 1-13.84-36.81L448.11 256l-109.94-96.19a21 21 0 0 1 27.66-31.61l128 112a21 21 0 0 1 0 31.6l-128 112A20.89 20.89 0 0 1 352 389z",
              fill: "currentColor"
            },
            null,
            -1
            /* HOISTED */
          ),
          (0, vue_1.createElementVNode)(
            "path",
            {
              d: "M208 437a21 21 0 0 1-20.12-27l96-320a21 21 0 1 1 40.23 12l-96 320A21 21 0 0 1 208 437z",
              fill: "currentColor"
            },
            null,
            -1
            /* HOISTED */
          )
        ])
      );
    }
  });
  return CodeSlash$1;
}
var CodeSlashExports = /* @__PURE__ */ requireCodeSlash();
const CodeSlash = /* @__PURE__ */ getDefaultExportFromCjs(CodeSlashExports);
var TrashOutline$1 = {};
var hasRequiredTrashOutline;
function requireTrashOutline() {
  if (hasRequiredTrashOutline) return TrashOutline$1;
  hasRequiredTrashOutline = 1;
  Object.defineProperty(TrashOutline$1, "__esModule", { value: true });
  const vue_1 = requireVue();
  const _hoisted_110 = {
    xmlns: "http://www.w3.org/2000/svg",
    "xmlns:xlink": "http://www.w3.org/1999/xlink",
    viewBox: "0 0 512 512"
  };
  TrashOutline$1.default = (0, vue_1.defineComponent)({
    name: "TrashOutline",
    render: function render(_ctx, _cache) {
      return (0, vue_1.openBlock)(), (0, vue_1.createElementBlock)("svg", _hoisted_110, _cache[0] || (_cache[0] = [(0, vue_1.createStaticVNode)('<path d="M112 112l20 320c.95 18.49 14.4 32 32 32h184c17.67 0 30.87-13.51 32-32l20-320" fill="none" stroke="currentColor" stroke-linecap="round" stroke-linejoin="round" stroke-width="32"></path><path stroke="currentColor" stroke-linecap="round" stroke-miterlimit="10" stroke-width="32" d="M80 112h352" fill="currentColor"></path><path d="M192 112V72h0a23.93 23.93 0 0 1 24-24h80a23.93 23.93 0 0 1 24 24h0v40" fill="none" stroke="currentColor" stroke-linecap="round" stroke-linejoin="round" stroke-width="32"></path><path fill="none" stroke="currentColor" stroke-linecap="round" stroke-linejoin="round" stroke-width="32" d="M256 176v224"></path><path fill="none" stroke="currentColor" stroke-linecap="round" stroke-linejoin="round" stroke-width="32" d="M184 176l8 224"></path><path fill="none" stroke="currentColor" stroke-linecap="round" stroke-linejoin="round" stroke-width="32" d="M328 176l-8 224"></path>', 6)]));
    }
  });
  return TrashOutline$1;
}
var TrashOutlineExports = /* @__PURE__ */ requireTrashOutline();
const TrashOutline = /* @__PURE__ */ getDefaultExportFromCjs(TrashOutlineExports);
var AddTaskRound$1 = {};
var hasRequiredAddTaskRound;
function requireAddTaskRound() {
  if (hasRequiredAddTaskRound) return AddTaskRound$1;
  hasRequiredAddTaskRound = 1;
  Object.defineProperty(AddTaskRound$1, "__esModule", { value: true });
  const vue_1 = requireVue();
  const _hoisted_110 = {
    xmlns: "http://www.w3.org/2000/svg",
    "xmlns:xlink": "http://www.w3.org/1999/xlink",
    viewBox: "0 0 24 24"
  };
  AddTaskRound$1.default = (0, vue_1.defineComponent)({
    name: "AddTaskRound",
    render: function render(_ctx, _cache) {
      return (0, vue_1.openBlock)(), (0, vue_1.createElementBlock)(
        "svg",
        _hoisted_110,
        _cache[0] || (_cache[0] = [
          (0, vue_1.createElementVNode)(
            "path",
            {
              d: "M21.29 5.89l-10 10a.996.996 0 0 1-1.41 0l-2.83-2.83a.996.996 0 1 1 1.41-1.41l2.12 2.12l9.29-9.29a.996.996 0 0 1 1.41 0c.4.39.4 1.02.01 1.41zM12 20c-4.71 0-8.48-4.09-7.95-8.9c.39-3.52 3.12-6.41 6.61-6.99c1.81-.3 3.53.02 4.99.78a1.003 1.003 0 0 0 .93-1.78c-1.47-.75-3.13-1.16-4.9-1.11c-5.14.16-9.41 4.34-9.67 9.47C1.72 17.24 6.3 22 12 22c1.2 0 2.34-.21 3.41-.6c.68-.25.87-1.13.35-1.65a.98.98 0 0 0-1.04-.23c-.85.31-1.77.48-2.72.48zm7-5h-2c-.55 0-1 .45-1 1s.45 1 1 1h2v2c0 .55.45 1 1 1s1-.45 1-1v-2h2c.55 0 1-.45 1-1s-.45-1-1-1h-2v-2c0-.55-.45-1-1-1s-1 .45-1 1v2z",
              fill: "currentColor"
            },
            null,
            -1
            /* HOISTED */
          )
        ])
      );
    }
  });
  return AddTaskRound$1;
}
var AddTaskRoundExports = /* @__PURE__ */ requireAddTaskRound();
const AddTaskRound = /* @__PURE__ */ getDefaultExportFromCjs(AddTaskRoundExports);
var PlusRound$1 = {};
var hasRequiredPlusRound;
function requirePlusRound() {
  if (hasRequiredPlusRound) return PlusRound$1;
  hasRequiredPlusRound = 1;
  Object.defineProperty(PlusRound$1, "__esModule", { value: true });
  const vue_1 = requireVue();
  const _hoisted_110 = {
    xmlns: "http://www.w3.org/2000/svg",
    "xmlns:xlink": "http://www.w3.org/1999/xlink",
    viewBox: "0 0 24 24"
  };
  PlusRound$1.default = (0, vue_1.defineComponent)({
    name: "PlusRound",
    render: function render(_ctx, _cache) {
      return (0, vue_1.openBlock)(), (0, vue_1.createElementBlock)(
        "svg",
        _hoisted_110,
        _cache[0] || (_cache[0] = [
          (0, vue_1.createElementVNode)(
            "path",
            {
              d: "M18 12.998h-5v5a1 1 0 0 1-2 0v-5H6a1 1 0 0 1 0-2h5v-5a1 1 0 0 1 2 0v5h5a1 1 0 0 1 0 2z",
              fill: "currentColor"
            },
            null,
            -1
            /* HOISTED */
          )
        ])
      );
    }
  });
  return PlusRound$1;
}
var PlusRoundExports = /* @__PURE__ */ requirePlusRound();
const PlusRound = /* @__PURE__ */ getDefaultExportFromCjs(PlusRoundExports);
var BugOutline$1 = {};
var hasRequiredBugOutline;
function requireBugOutline() {
  if (hasRequiredBugOutline) return BugOutline$1;
  hasRequiredBugOutline = 1;
  Object.defineProperty(BugOutline$1, "__esModule", { value: true });
  const vue_1 = requireVue();
  const _hoisted_110 = {
    xmlns: "http://www.w3.org/2000/svg",
    "xmlns:xlink": "http://www.w3.org/1999/xlink",
    viewBox: "0 0 512 512"
  };
  BugOutline$1.default = (0, vue_1.defineComponent)({
    name: "BugOutline",
    render: function render(_ctx, _cache) {
      return (0, vue_1.openBlock)(), (0, vue_1.createElementBlock)("svg", _hoisted_110, _cache[0] || (_cache[0] = [(0, vue_1.createStaticVNode)('<path d="M370 378c28.89 23.52 46 46.07 46 86" fill="none" stroke="currentColor" stroke-linecap="round" stroke-linejoin="round" stroke-width="32"></path><path d="M142 378c-28.89 23.52-46 46.06-46 86" fill="none" stroke="currentColor" stroke-linecap="round" stroke-linejoin="round" stroke-width="32"></path><path d="M384 208c28.89-23.52 32-56.07 32-96" fill="none" stroke="currentColor" stroke-linecap="round" stroke-linejoin="round" stroke-width="32"></path><path d="M128 206c-28.89-23.52-32-54.06-32-94" fill="none" stroke="currentColor" stroke-linecap="round" stroke-linejoin="round" stroke-width="32"></path><path fill="none" stroke="currentColor" stroke-linecap="round" stroke-linejoin="round" stroke-width="32" d="M464 288.13h-80"></path><path fill="none" stroke="currentColor" stroke-linecap="round" stroke-linejoin="round" stroke-width="32" d="M128 288.13H48"></path><path fill="none" stroke="currentColor" stroke-linecap="round" stroke-linejoin="round" stroke-width="32" d="M256 192v256"></path><path d="M256 448h0c-70.4 0-128-57.6-128-128v-96.07c0-65.07 57.6-96 128-96h0c70.4 0 128 25.6 128 96V320c0 70.4-57.6 128-128 128z" fill="none" stroke="currentColor" stroke-linecap="round" stroke-linejoin="round" stroke-width="32"></path><path d="M179.43 143.52a49.08 49.08 0 0 1-3.43-15.73A80 80 0 0 1 255.79 48h.42A80 80 0 0 1 336 127.79a41.91 41.91 0 0 1-3.12 14.3" fill="none" stroke="currentColor" stroke-linecap="round" stroke-linejoin="round" stroke-width="32"></path>', 9)]));
    }
  });
  return BugOutline$1;
}
var BugOutlineExports = /* @__PURE__ */ requireBugOutline();
const BugOutline = /* @__PURE__ */ getDefaultExportFromCjs(BugOutlineExports);
const _hoisted_1 = { class: "plan-bar w-980 mx-auto mt-12 mw-980" };
const _sfc_main = {
  __name: "Plan",
  setup(__props) {
    const config_store = useConfigStore();
    const { conf } = storeToRefs(config_store);
    const plan_store = usePlanStore();
    const {
      ling_xi,
      max_resting_count,
      resting_priority,
      exhaust_require,
      rest_in_full,
      workaholic,
      backup_plans,
      sub_plan,
      refresh_trading
    } = storeToRefs(plan_store);
    const { load_plan, fill_empty } = plan_store;
    const axios = inject("axios");
    const facility = ref("");
    provide("facility", facility);
    const plan_editor = ref(null);
    const generating_image = ref(false);
    const message = useMessage();
    const loading_bar = useLoadingBar();
    async function save() {
      generating_image.value = true;
      loading_bar.start();
      if (facility.value != "") {
        facility.value = "";
        await sleep(500);
      }
      const browser = Bowser.getParser(window.navigator.userAgent);
      let blob;
      if (browser.getEngine().name == "WebKit") {
        blob = await toBlob(plan_editor.value.outer);
      }
      blob = await toBlob(plan_editor.value.outer, {
        pixelRatio: 3,
        backgroundColor: "#ffffff",
        style: { margin: 0, padding: "8px 0" }
      });
      generating_image.value = false;
      loading_bar.finish();
      const form_data = new FormData();
      form_data.append("img", blob);
      const { data } = await axios.post(`${""}/dialog/save/img`, form_data, {
        responseType: "blob"
      });
      const url = window.URL.createObjectURL(data);
      const link = document.createElement("a");
      link.href = url;
      link.setAttribute("download", "plan.jpg");
      document.body.appendChild(link);
      link.click();
      document.body.removeChild(link);
      window.URL.revokeObjectURL(url);
    }
    const mobile = inject("mobile");
    const sub_plan_options = computed(() => {
      const result = [
        {
          label: "主表",
          value: "main"
        }
      ];
      for (let i = 0; i < backup_plans.value.length; i++) {
        result.push({
          label: `副表${i + 1}`,
          value: i
        });
      }
      return result;
    });
    function create_sub_plan() {
      backup_plans.value.push({
        conf: {
          exhaust_require: deepcopy(exhaust_require.value),
          free_blacklist: deepcopy(conf.value.free_blacklist),
          ling_xi: ling_xi.value,
          max_resting_count: max_resting_count.value,
          rest_in_full: deepcopy(rest_in_full.value),
          resting_priority: deepcopy(resting_priority.value),
          workaholic: deepcopy(workaholic.value),
          refresh_trading: deepcopy(refresh_trading.value)
        },
        plan: fill_empty({}),
        trigger: {
          left: "",
          operator: "",
          right: ""
        },
        trigger_timing: "AFTER_PLANNING",
        task: {}
      });
      sub_plan.value = backup_plans.value.length - 1;
    }
    function delete_sub_plan() {
      backup_plans.value.splice(sub_plan.value, 1);
      sub_plan.value = "main";
    }
    const current_conf = ref({
      ling_xi: ling_xi.value,
      max_resting_count: max_resting_count.value,
      rest_in_full: rest_in_full.value,
      resting_priority: resting_priority.value,
      workaholic: workaholic.value,
      exhaust_require: exhaust_require.value,
      refresh_trading: refresh_trading.value
    });
    watchEffect(() => {
      if (sub_plan.value == "main") {
        current_conf.value = {
          ling_xi: ling_xi.value,
          max_resting_count: max_resting_count.value,
          rest_in_full: rest_in_full.value,
          resting_priority: resting_priority.value,
          workaholic: workaholic.value,
          exhaust_require: exhaust_require.value,
          refresh_trading: refresh_trading.value
        };
      } else {
        current_conf.value = backup_plans.value[sub_plan.value].conf;
      }
    });
    watchEffect(() => {
      if (sub_plan.value == "main") {
        ling_xi.value = current_conf.value.ling_xi;
        max_resting_count.value = current_conf.value.max_resting_count;
        rest_in_full.value = current_conf.value.rest_in_full;
        exhaust_require.value = current_conf.value.exhaust_require;
        resting_priority.value = current_conf.value.resting_priority;
        workaholic.value = current_conf.value.workaholic;
        refresh_trading.value = current_conf.value.refresh_trading;
      } else {
        backup_plans.value[sub_plan.value].conf = current_conf.value;
      }
    });
    const show_trigger_editor = ref(false);
    provide("show_trigger_editor", show_trigger_editor);
    const show_task = ref(false);
    const add_task = ref(false);
    provide("show_task", show_task);
    provide("add_task", add_task);
    function import_plan2({ event }) {
      const msg = event.target.response;
      if (msg == "排班已加载") {
        sub_plan.value = "main";
        load_plan();
        message.success("成功导入排班表！");
      } else {
        message.error(msg);
      }
    }
    const import_url = `${""}/import`;
    const token = inject("token");
    const export_options = [
      {
        label: "导出JSON文件",
        key: "json"
      }
    ];
    async function export_json() {
      const { data } = await axios.get(`${""}/export-json`, {
        responseType: "blob"
      });
      const url = window.URL.createObjectURL(data);
      const link = document.createElement("a");
      link.href = url;
      link.setAttribute("download", "plan.json");
      document.body.appendChild(link);
      link.click();
      document.body.removeChild(link);
      window.URL.revokeObjectURL(url);
    }
    const plan_check_loading = ref(false);
    const plan_check_modal = ref(false);
    const plan_check_status = ref("success");
    const plan_check_msg = ref("");
    async function plan_check() {
      plan_check_loading.value = true;
      const { data } = await axios.get(`${""}/plan/check`);
      plan_check_loading.value = false;
      const { error, msg } = data;
      plan_check_status.value = error ? "error" : "success";
      plan_check_msg.value = msg;
      plan_check_modal.value = true;
    }
    const show_paomadeng = inject("show_paomadeng");
    onMounted(() => {
      show_paomadeng.value = false;
    });
    return (_ctx, _cache) => {
      const _component_trigger_dialog = _sfc_main$1;
      const _component_task_dialog = __unplugin_components_1;
      const _component_n_icon = NIcon;
      const _component_n_button = Button;
      const _component_n_button_group = __unplugin_components_9$1;
      const _component_n_select = __unplugin_components_5;
      const _component_n_tooltip = __unplugin_components_6;
      const _component_n_upload = __unplugin_components_7$1;
      const _component_drop_down = __unplugin_components_8;
      const _component_plan_editor = __unplugin_components_9;
      const _component_help_text = __unplugin_components_0$1;
      const _component_n_radio = __unplugin_components_11;
      const _component_n_space = __unplugin_components_12;
      const _component_n_radio_group = __unplugin_components_13;
      const _component_n_form_item = __unplugin_components_14;
      const _component_n_input_number = __unplugin_components_15;
      const _component_slick_operator_select = __unplugin_components_16;
      const _component_n_form = __unplugin_components_17;
      const _component_n_result = __unplugin_components_18;
      const _component_n_modal = __unplugin_components_4$1;
      return openBlock(), createElementBlock(Fragment, null, [
        createVNode(_component_trigger_dialog),
        createVNode(_component_task_dialog),
        createBaseVNode("div", _hoisted_1, [
          createVNode(_component_n_button_group, null, {
            default: withCtx(() => [
              createVNode(_component_n_button, {
                disabled: unref(sub_plan) == "main",
                onClick: _cache[0] || (_cache[0] = ($event) => sub_plan.value = unref(sub_plan) == 0 ? "main" : unref(sub_plan) - 1)
              }, {
                icon: withCtx(() => [
                  createVNode(_component_n_icon, null, {
                    default: withCtx(() => [
                      createVNode(unref(IosArrowBack))
                    ]),
                    _: 1
                  })
                ]),
                _: 1
              }, 8, ["disabled"]),
              createVNode(_component_n_button, {
                disabled: unref(sub_plan) == unref(backup_plans).length - 1 || unref(backup_plans).length == 0,
                onClick: _cache[1] || (_cache[1] = ($event) => sub_plan.value = unref(sub_plan) == "main" ? 0 : unref(sub_plan) + 1)
              }, {
                icon: withCtx(() => [
                  createVNode(_component_n_icon, null, {
                    default: withCtx(() => [
                      createVNode(unref(IosArrowForward))
                    ]),
                    _: 1
                  })
                ]),
                _: 1
              }, 8, ["disabled"])
            ]),
            _: 1
          }),
          createVNode(_component_n_select, {
            value: unref(sub_plan),
            "onUpdate:value": _cache[2] || (_cache[2] = ($event) => isRef(sub_plan) ? sub_plan.value = $event : null),
            options: unref(sub_plan_options)
          }, null, 8, ["value", "options"]),
          createVNode(_component_n_button_group, null, {
            default: withCtx(() => [
              createVNode(_component_n_tooltip, { trigger: "hover" }, {
                trigger: withCtx(() => [
                  createVNode(_component_n_button, { onClick: create_sub_plan }, {
                    icon: withCtx(() => [
                      createVNode(_component_n_icon, { size: 22 }, {
                        default: withCtx(() => [
                          createVNode(unref(PlusRound))
                        ]),
                        _: 1
                      })
                    ]),
                    _: 1
                  })
                ]),
                default: withCtx(() => [
                  _cache[15] || (_cache[15] = createTextVNode(" 新建副表 "))
                ]),
                _: 1
              }),
              createVNode(_component_n_tooltip, { trigger: "hover" }, {
                trigger: withCtx(() => [
                  createVNode(_component_n_button, {
                    disabled: unref(sub_plan) == "main",
                    onClick: _cache[3] || (_cache[3] = ($event) => show_trigger_editor.value = true)
                  }, {
                    icon: withCtx(() => [
                      createVNode(_component_n_icon, null, {
                        default: withCtx(() => [
                          createVNode(unref(CodeSlash))
                        ]),
                        _: 1
                      })
                    ]),
                    _: 1
                  }, 8, ["disabled"])
                ]),
                default: withCtx(() => [
                  _cache[16] || (_cache[16] = createTextVNode(" 编辑触发条件 "))
                ]),
                _: 1
              }),
              createVNode(_component_n_tooltip, { trigger: "hover" }, {
                trigger: withCtx(() => [
                  createVNode(_component_n_button, {
                    disabled: unref(sub_plan) == "main",
                    onClick: _cache[4] || (_cache[4] = ($event) => show_task.value = true)
                  }, {
                    icon: withCtx(() => [
                      createVNode(_component_n_icon, null, {
                        default: withCtx(() => [
                          createVNode(unref(AddTaskRound))
                        ]),
                        _: 1
                      })
                    ]),
                    _: 1
                  }, 8, ["disabled"])
                ]),
                default: withCtx(() => [
                  _cache[17] || (_cache[17] = createTextVNode(" 编辑任务 "))
                ]),
                _: 1
              }),
              createVNode(_component_n_tooltip, { trigger: "hover" }, {
                trigger: withCtx(() => [
                  createVNode(_component_n_button, {
                    disabled: unref(sub_plan) == "main",
                    onClick: delete_sub_plan
                  }, {
                    icon: withCtx(() => [
                      createVNode(_component_n_icon, null, {
                        default: withCtx(() => [
                          createVNode(unref(TrashOutline))
                        ]),
                        _: 1
                      })
                    ]),
                    _: 1
                  }, 8, ["disabled"])
                ]),
                default: withCtx(() => [
                  _cache[18] || (_cache[18] = createTextVNode(" 删除此副表 "))
                ]),
                _: 1
              })
            ]),
            _: 1
          }),
          createVNode(_component_n_button, {
            onClick: plan_check,
            style: { "margin": "0 12px" },
            loading: unref(plan_check_loading),
            disabled: unref(plan_check_loading)
          }, {
            icon: withCtx(() => [
              createVNode(_component_n_icon, null, {
                default: withCtx(() => [
                  createVNode(unref(BugOutline))
                ]),
                _: 1
              })
            ]),
            default: withCtx(() => [
              _cache[19] || (_cache[19] = createTextVNode(" 排班校验 "))
            ]),
            _: 1
          }, 8, ["loading", "disabled"]),
          createVNode(_component_n_upload, {
            style: { "width": "auto" },
            action: import_url,
            headers: { token: unref(token) },
            "show-file-list": false,
            name: "img",
            onFinish: import_plan2
          }, {
            default: withCtx(() => [
              createVNode(_component_n_button, null, {
                icon: withCtx(() => [
                  createVNode(_component_n_icon, null, {
                    default: withCtx(() => [
                      createVNode(unref(DocumentImport))
                    ]),
                    _: 1
                  })
                ]),
                default: withCtx(() => [
                  _cache[20] || (_cache[20] = createTextVNode(" 导入排班 "))
                ]),
                _: 1
              })
            ]),
            _: 1
          }, 8, ["headers"]),
          createVNode(_component_drop_down, {
            select: export_json,
            options: export_options
          }, {
            default: withCtx(() => [
              createVNode(_component_n_button, {
                onClick: save,
                loading: unref(generating_image),
                disabled: unref(generating_image)
              }, {
                icon: withCtx(() => [
                  createVNode(_component_n_icon, null, {
                    default: withCtx(() => [
                      createVNode(unref(DocumentExport))
                    ]),
                    _: 1
                  })
                ]),
                default: withCtx(() => [
                  _cache[21] || (_cache[21] = createTextVNode(" 导出图片 "))
                ]),
                _: 1
              }, 8, ["loading", "disabled"])
            ]),
            _: 1
          })
        ]),
        createVNode(_component_plan_editor, {
          ref_key: "plan_editor",
          ref: plan_editor,
          class: "w-980 mx-auto mw-980 px-12"
        }, null, 512),
        createVNode(_component_n_form, {
          class: "w-980 mx-auto mb-12 px-12 mw-980",
          "label-placement": unref(mobile) ? "top" : "left",
          "show-feedback": false,
          "label-width": "160",
          "label-align": "left"
        }, {
          default: withCtx(() => [
            createVNode(_component_n_form_item, null, {
              label: withCtx(() => [
                _cache[23] || (_cache[23] = createBaseVNode("span", null, "令夕模式", -1)),
                createVNode(_component_help_text, null, {
                  default: withCtx(() => _cache[22] || (_cache[22] = [
                    createBaseVNode("div", null, "令夕上班时起作用", -1),
                    createBaseVNode("div", null, "需要手动对齐心情", -1),
                    createBaseVNode("div", null, "感知：夕心情-令心情=12", -1),
                    createBaseVNode("div", null, "烟火：令心情-夕心情=12", -1),
                    createBaseVNode("div", null, "均衡：夕令心情一样", -1)
                  ])),
                  _: 1
                })
              ]),
              default: withCtx(() => [
                createVNode(_component_n_radio_group, {
                  value: unref(current_conf).ling_xi,
                  "onUpdate:value": _cache[5] || (_cache[5] = ($event) => unref(current_conf).ling_xi = $event)
                }, {
                  default: withCtx(() => [
                    createVNode(_component_n_space, null, {
                      default: withCtx(() => [
                        createVNode(_component_n_radio, { value: 1 }, {
                          default: withCtx(() => _cache[24] || (_cache[24] = [
                            createTextVNode("感知信息")
                          ])),
                          _: 1
                        }),
                        createVNode(_component_n_radio, { value: 2 }, {
                          default: withCtx(() => _cache[25] || (_cache[25] = [
                            createTextVNode("人间烟火")
                          ])),
                          _: 1
                        }),
                        createVNode(_component_n_radio, { value: 3 }, {
                          default: withCtx(() => _cache[26] || (_cache[26] = [
                            createTextVNode("均衡模式")
                          ])),
                          _: 1
                        })
                      ]),
                      _: 1
                    })
                  ]),
                  _: 1
                }, 8, ["value"])
              ]),
              _: 1
            }),
            createVNode(_component_n_form_item, { label: "宿舍单回位数量" }, {
              default: withCtx(() => [
                createVNode(_component_n_input_number, {
                  value: unref(current_conf).max_resting_count,
                  "onUpdate:value": _cache[6] || (_cache[6] = ($event) => unref(current_conf).max_resting_count = $event)
                }, {
                  suffix: withCtx(() => _cache[27] || (_cache[27] = [
                    createTextVNode("人")
                  ])),
                  _: 1
                }, 8, ["value"])
              ]),
              _: 1
            }),
            createVNode(_component_n_form_item, { label: "需要回满心情的干员" }, {
              default: withCtx(() => [
                createVNode(_component_slick_operator_select, {
                  modelValue: unref(current_conf).rest_in_full,
                  "onUpdate:modelValue": _cache[7] || (_cache[7] = ($event) => unref(current_conf).rest_in_full = $event)
                }, null, 8, ["modelValue"])
              ]),
              _: 1
            }),
            createVNode(_component_n_form_item, { label: "需要用尽心情的干员" }, {
              default: withCtx(() => [
                createVNode(_component_slick_operator_select, {
                  modelValue: unref(current_conf).exhaust_require,
                  "onUpdate:modelValue": _cache[8] || (_cache[8] = ($event) => unref(current_conf).exhaust_require = $event)
                }, null, 8, ["modelValue"])
              ]),
              _: 1
            }),
            createVNode(_component_n_form_item, { label: "宿舍黑名单（主力）" }, {
              default: withCtx(() => [
                createVNode(_component_slick_operator_select, {
                  modelValue: unref(current_conf).workaholic,
                  "onUpdate:modelValue": _cache[9] || (_cache[9] = ($event) => unref(current_conf).workaholic = $event)
                }, null, 8, ["modelValue"])
              ]),
              _: 1
            }),
            createVNode(_component_n_form_item, { label: "在群回位休息的干员" }, {
              default: withCtx(() => [
                createVNode(_component_slick_operator_select, {
                  modelValue: unref(current_conf).resting_priority,
                  "onUpdate:modelValue": _cache[10] || (_cache[10] = ($event) => unref(current_conf).resting_priority = $event)
                }, null, 8, ["modelValue"])
              ]),
              _: 1
            }),
            createVNode(_component_n_form_item, null, {
              label: withCtx(() => [
                _cache[29] || (_cache[29] = createBaseVNode("span", null, "跑单时间刷新干员", -1)),
                createVNode(_component_help_text, null, {
                  default: withCtx(() => _cache[28] || (_cache[28] = [
                    createBaseVNode("p", null, "贸易站外影响贸易效率的干员", -1),
                    createBaseVNode("p", null, [
                      createTextVNode(" 默认情况下，mower-ng 只在贸易站内干员换班后重读其所在贸易站的订单剩余时间。"),
                      createBaseVNode("br"),
                      createTextVNode(" 若有贸易站外的干员影响贸易效率，且与贸易站内的干员不在一组，则需写入此选项中。 ")
                    ], -1)
                  ])),
                  _: 1
                })
              ]),
              default: withCtx(() => [
                createVNode(_component_slick_operator_select, {
                  modelValue: unref(current_conf).refresh_trading,
                  "onUpdate:modelValue": _cache[11] || (_cache[11] = ($event) => unref(current_conf).refresh_trading = $event),
                  select_placeholder: "填入在贸易站外影响贸易效率的干员"
                }, null, 8, ["modelValue"])
              ]),
              _: 1
            }),
            unref(sub_plan) != "main" ? (openBlock(), createBlock(_component_n_form_item, {
              key: 0,
              label: "宿舍黑名单（非主力）"
            }, {
              default: withCtx(() => [
                createVNode(_component_slick_operator_select, {
                  modelValue: unref(current_conf).free_blacklist,
                  "onUpdate:modelValue": _cache[12] || (_cache[12] = ($event) => unref(current_conf).free_blacklist = $event)
                }, null, 8, ["modelValue"])
              ]),
              _: 1
            })) : createCommentVNode("", true)
          ]),
          _: 1
        }, 8, ["label-placement"]),
        createVNode(_component_n_modal, {
          show: unref(plan_check_modal),
          "onUpdate:show": _cache[14] || (_cache[14] = ($event) => isRef(plan_check_modal) ? plan_check_modal.value = $event : null),
          "transform-origin": "center",
          preset: "card",
          style: { "width": "600px" }
        }, {
          default: withCtx(() => [
            createVNode(_component_n_result, {
              status: unref(plan_check_status),
              title: unref(plan_check_msg)
            }, {
              footer: withCtx(() => [
                createVNode(_component_n_button, {
                  onClick: _cache[13] || (_cache[13] = ($event) => plan_check_modal.value = false)
                }, {
                  default: withCtx(() => _cache[30] || (_cache[30] = [
                    createTextVNode("关闭")
                  ])),
                  _: 1
                })
              ]),
              _: 1
            }, 8, ["status", "title"])
          ]),
          _: 1
        }, 8, ["show"])
      ], 64);
    };
  }
};
const Plan = /* @__PURE__ */ _export_sfc(_sfc_main, [["__scopeId", "data-v-d06834f4"]]);
export {
  Plan as default
};
