import { derived, cB, cE, c, defineComponent, useConfig, useTheme, useRtl, computed, useThemeClass, h, Fragment, defineStore, axios, _export_sfc, ref, onMounted, createElementBlock, createVNode, withCtx, openBlock, createTextVNode, toDisplayString, createBaseVNode, Button, renderList, createBlock } from "./index.js";
import { NH2 } from "./headers.js";
import { useMessage } from "./use-message.js";
import { __unplugin_components_3, __unplugin_components_2 } from "./Grid.js";
import { __unplugin_components_2 as __unplugin_components_2$1 } from "./Flex.js";
import { __unplugin_components_0, __unplugin_components_3 as __unplugin_components_3$1 } from "./text.js";
import { __unplugin_components_1 } from "./Alert.js";
import { __unplugin_components_7 } from "./Avatar.js";
import "./get-slot.js";
import "./next-frame-once.js";
import "./use-compitable.js";
import "./utils.js";
import "./Tag.js";
function self(vars) {
  const {
    textColor1,
    textColor2,
    fontWeightStrong,
    fontSize
  } = vars;
  return {
    fontSize,
    titleTextColor: textColor1,
    textColor: textColor2,
    titleFontWeight: fontWeightStrong
  };
}
const thingLight = {
  common: derived,
  self
};
const style = cB("thing", `
 display: flex;
 transition: color .3s var(--n-bezier);
 font-size: var(--n-font-size);
 color: var(--n-text-color);
`, [cB("thing-avatar", `
 margin-right: 12px;
 margin-top: 2px;
 `), cB("thing-avatar-header-wrapper", `
 display: flex;
 flex-wrap: nowrap;
 `, [cB("thing-header-wrapper", `
 flex: 1;
 `)]), cB("thing-main", `
 flex-grow: 1;
 `, [cB("thing-header", `
 display: flex;
 margin-bottom: 4px;
 justify-content: space-between;
 align-items: center;
 `, [cE("title", `
 font-size: 16px;
 font-weight: var(--n-title-font-weight);
 transition: color .3s var(--n-bezier);
 color: var(--n-title-text-color);
 `)]), cE("description", [c("&:not(:last-child)", `
 margin-bottom: 4px;
 `)]), cE("content", [c("&:not(:first-child)", `
 margin-top: 12px;
 `)]), cE("footer", [c("&:not(:first-child)", `
 margin-top: 12px;
 `)]), cE("action", [c("&:not(:first-child)", `
 margin-top: 12px;
 `)])])]);
const thingProps = Object.assign(Object.assign({}, useTheme.props), {
  title: String,
  titleExtra: String,
  description: String,
  descriptionClass: String,
  descriptionStyle: [String, Object],
  content: String,
  contentClass: String,
  contentStyle: [String, Object],
  contentIndented: Boolean
});
const __unplugin_components_8 = defineComponent({
  name: "Thing",
  props: thingProps,
  slots: Object,
  setup(props, {
    slots
  }) {
    const {
      mergedClsPrefixRef,
      inlineThemeDisabled,
      mergedRtlRef
    } = useConfig(props);
    const themeRef = useTheme("Thing", "-thing", style, thingLight, props, mergedClsPrefixRef);
    const rtlEnabledRef = useRtl("Thing", mergedRtlRef, mergedClsPrefixRef);
    const cssVarsRef = computed(() => {
      const {
        self: {
          titleTextColor,
          textColor,
          titleFontWeight,
          fontSize
        },
        common: {
          cubicBezierEaseInOut
        }
      } = themeRef.value;
      return {
        "--n-bezier": cubicBezierEaseInOut,
        "--n-font-size": fontSize,
        "--n-text-color": textColor,
        "--n-title-font-weight": titleFontWeight,
        "--n-title-text-color": titleTextColor
      };
    });
    const themeClassHandle = inlineThemeDisabled ? useThemeClass("thing", void 0, cssVarsRef, props) : void 0;
    return () => {
      var _a;
      const {
        value: mergedClsPrefix
      } = mergedClsPrefixRef;
      const rtlEnabled = rtlEnabledRef ? rtlEnabledRef.value : false;
      (_a = themeClassHandle === null || themeClassHandle === void 0 ? void 0 : themeClassHandle.onRender) === null || _a === void 0 ? void 0 : _a.call(themeClassHandle);
      return h("div", {
        class: [`${mergedClsPrefix}-thing`, themeClassHandle === null || themeClassHandle === void 0 ? void 0 : themeClassHandle.themeClass, rtlEnabled && `${mergedClsPrefix}-thing--rtl`],
        style: inlineThemeDisabled ? void 0 : cssVarsRef.value
      }, slots.avatar && props.contentIndented ? h("div", {
        class: `${mergedClsPrefix}-thing-avatar`
      }, slots.avatar()) : null, h("div", {
        class: `${mergedClsPrefix}-thing-main`
      }, !props.contentIndented && (slots.header || props.title || slots["header-extra"] || props.titleExtra || slots.avatar) ? h("div", {
        class: `${mergedClsPrefix}-thing-avatar-header-wrapper`
      }, slots.avatar ? h("div", {
        class: `${mergedClsPrefix}-thing-avatar`
      }, slots.avatar()) : null, slots.header || props.title || slots["header-extra"] || props.titleExtra ? h("div", {
        class: `${mergedClsPrefix}-thing-header-wrapper`
      }, h("div", {
        class: `${mergedClsPrefix}-thing-header`
      }, slots.header || props.title ? h("div", {
        class: `${mergedClsPrefix}-thing-header__title`
      }, slots.header ? slots.header() : props.title) : null, slots["header-extra"] || props.titleExtra ? h("div", {
        class: `${mergedClsPrefix}-thing-header__extra`
      }, slots["header-extra"] ? slots["header-extra"]() : props.titleExtra) : null), slots.description || props.description ? h("div", {
        class: [`${mergedClsPrefix}-thing-main__description`, props.descriptionClass],
        style: props.descriptionStyle
      }, slots.description ? slots.description() : props.description) : null) : null) : h(Fragment, null, slots.header || props.title || slots["header-extra"] || props.titleExtra ? h("div", {
        class: `${mergedClsPrefix}-thing-header`
      }, slots.header || props.title ? h("div", {
        class: `${mergedClsPrefix}-thing-header__title`
      }, slots.header ? slots.header() : props.title) : null, slots["header-extra"] || props.titleExtra ? h("div", {
        class: `${mergedClsPrefix}-thing-header__extra`
      }, slots["header-extra"] ? slots["header-extra"]() : props.titleExtra) : null) : null, slots.description || props.description ? h("div", {
        class: [`${mergedClsPrefix}-thing-main__description`, props.descriptionClass],
        style: props.descriptionStyle
      }, slots.description ? slots.description() : props.description) : null), slots.default || props.content ? h("div", {
        class: [`${mergedClsPrefix}-thing-main__content`, props.contentClass],
        style: props.contentStyle
      }, slots.default ? slots.default() : props.content) : null, slots.footer ? h("div", {
        class: `${mergedClsPrefix}-thing-main__footer`
      }, slots.footer()) : null, slots.action ? h("div", {
        class: `${mergedClsPrefix}-thing-main__action`
      }, slots.action()) : null));
    };
  }
});
const usedepotStore = defineStore("depot", () => {
  async function getDepotinfo() {
    const response = await axios.get(`${""}/depot/readdepot`);
    return response.data;
  }
  return {
    getDepotinfo
  };
});
const _sfc_main = {
  __name: "depot",
  setup(__props) {
    const depotStore = usedepotStore();
    const { getDepotinfo } = depotStore;
    const message = useMessage();
    const reportData = ref([]);
    const sortedCategories = computed(() => {
      const data = reportData.value[0] || {};
      return Object.entries(data).map(([category, items]) => [
        category,
        Object.entries(items).map(([key, value]) => ({ key, ...value })).sort((a, b) => a.sort - b.sort)
      ]);
    });
    const fetchData = async () => {
      try {
        reportData.value = await getDepotinfo();
      } catch (error) {
        message.error("数据加载失败: " + error.message);
      }
    };
    const copyToClipboard = async () => {
      try {
        await navigator.clipboard.writeText(reportData.value[1]);
        message.success("已复制到剪贴板");
      } catch (err) {
        message.error("复制失败，请手动复制");
      }
    };
    const update_skland = async () => {
      try {
        await axios.post(`${""}/update/depot_skland`);
        await fetchData();
        message.success("仓库数据更新成功");
      } catch (error) {
        message.error("更新失败: " + error.message);
      }
    };
    onMounted(fetchData);
    return (_ctx, _cache) => {
      const _component_n_text = __unplugin_components_0;
      const _component_n_alert = __unplugin_components_1;
      const _component_n_flex = __unplugin_components_2$1;
      const _component_n_divider = __unplugin_components_3$1;
      const _component_n_gi = __unplugin_components_2;
      const _component_n_button = Button;
      const _component_n_h2 = NH2;
      const _component_n_avatar = __unplugin_components_7;
      const _component_n_thing = __unplugin_components_8;
      const _component_n_grid = __unplugin_components_3;
      return openBlock(), createElementBlock("div", null, [
        createVNode(_component_n_grid, {
          cols: "1",
          responsive: "screen"
        }, {
          default: withCtx(() => [
            createVNode(_component_n_gi, null, {
              default: withCtx(() => [
                createVNode(_component_n_flex, {
                  vertical: "",
                  class: "info-container"
                }, {
                  default: withCtx(() => [
                    createVNode(_component_n_text, { class: "scan-time" }, {
                      default: withCtx(() => [
                        createTextVNode("扫描时间：" + toDisplayString(reportData.value[2]), 1)
                      ]),
                      _: 1
                    }),
                    createVNode(_component_n_alert, {
                      type: "info",
                      bordered: false
                    }, {
                      default: withCtx(() => _cache[0] || (_cache[0] = [
                        createBaseVNode("div", { class: "notes" }, [
                          createBaseVNode("p", null, '注：图像识别扫描时，万以下的数字并不会计入，如"龙门币 245万" "资质凭证 2万"'),
                          createBaseVNode("p", null, '注：森空岛读取仓库中并不会识别"常用"下的材料，只识别材料')
                        ], -1)
                      ])),
                      _: 1
                    })
                  ]),
                  _: 1
                }),
                createVNode(_component_n_divider)
              ]),
              _: 1
            }),
            createVNode(_component_n_gi, null, {
              default: withCtx(() => [
                createVNode(_component_n_flex, { vertical: "" }, {
                  default: withCtx(() => [
                    createVNode(_component_n_flex, {
                      align: "center",
                      class: "action-group"
                    }, {
                      default: withCtx(() => [
                        createVNode(_component_n_text, null, {
                          default: withCtx(() => _cache[1] || (_cache[1] = [
                            createTextVNode("导出JSON数据到：")
                          ])),
                          _: 1
                        }),
                        createVNode(_component_n_button, {
                          type: "primary",
                          onClick: copyToClipboard,
                          class: "action-btn"
                        }, {
                          default: withCtx(() => _cache[2] || (_cache[2] = [
                            createTextVNode(" 明日方舟工具箱 ")
                          ])),
                          _: 1
                        })
                      ]),
                      _: 1
                    }),
                    createVNode(_component_n_flex, {
                      align: "center",
                      class: "action-group"
                    }, {
                      default: withCtx(() => [
                        createVNode(_component_n_text, null, {
                          default: withCtx(() => _cache[3] || (_cache[3] = [
                            createTextVNode("更新仓库数据：")
                          ])),
                          _: 1
                        }),
                        createVNode(_component_n_button, {
                          type: "info",
                          onClick: update_skland,
                          class: "action-btn"
                        }, {
                          default: withCtx(() => _cache[4] || (_cache[4] = [
                            createTextVNode(" 森空岛部分 ")
                          ])),
                          _: 1
                        })
                      ]),
                      _: 1
                    })
                  ]),
                  _: 1
                }),
                createVNode(_component_n_divider)
              ]),
              _: 1
            }),
            (openBlock(true), createElementBlock(Fragment, null, renderList(sortedCategories.value, ([categoryName, categoryItems]) => {
              return openBlock(), createBlock(_component_n_gi, { key: categoryName }, {
                default: withCtx(() => [
                  createVNode(_component_n_h2, { class: "category-title" }, {
                    default: withCtx(() => [
                      createTextVNode(toDisplayString(categoryName.slice(1)), 1)
                    ]),
                    _: 2
                  }, 1024),
                  createVNode(_component_n_grid, {
                    "x-gap": "12",
                    "y-gap": "12",
                    cols: "2 m:4 l:6",
                    responsive: "screen",
                    class: "material-grid"
                  }, {
                    default: withCtx(() => [
                      (openBlock(true), createElementBlock(Fragment, null, renderList(categoryItems, (itemData) => {
                        return openBlock(), createBlock(_component_n_gi, {
                          key: itemData.key,
                          class: "material-item"
                        }, {
                          default: withCtx(() => [
                            createVNode(_component_n_thing, { class: "material-card" }, {
                              avatar: withCtx(() => [
                                createVNode(_component_n_avatar, {
                                  color: "transparent",
                                  size: "large",
                                  src: "/depot/" + itemData["icon"] + ".webp",
                                  "object-fit": "contain"
                                }, null, 8, ["src"])
                              ]),
                              header: withCtx(() => [
                                createVNode(_component_n_text, { class: "material-name" }, {
                                  default: withCtx(() => [
                                    createTextVNode(toDisplayString(itemData.key), 1)
                                  ]),
                                  _: 2
                                }, 1024)
                              ]),
                              description: withCtx(() => [
                                createVNode(_component_n_text, {
                                  depth: "3",
                                  class: "material-count"
                                }, {
                                  default: withCtx(() => [
                                    createTextVNode("拥有：" + toDisplayString(itemData.number), 1)
                                  ]),
                                  _: 2
                                }, 1024)
                              ]),
                              _: 2
                            }, 1024)
                          ]),
                          _: 2
                        }, 1024);
                      }), 128))
                    ]),
                    _: 2
                  }, 1024),
                  createVNode(_component_n_divider)
                ]),
                _: 2
              }, 1024);
            }), 128))
          ]),
          _: 1
        })
      ]);
    };
  }
};
const depot = /* @__PURE__ */ _export_sfc(_sfc_main, [["__scopeId", "data-v-6f42e5d7"]]);
export {
  depot as default
};
