import { defineStore } from 'pinia'

import axios from 'axios'

export const useMowerStore = defineStore('mower', () => {
  const log_lines = ref([])

  const log = computed(() => {
    return log_lines.value.join('\n')
  })

  const num_reg = /^[0-9].*/
  const log_mobile = computed(() => {
    const result = []
    for (const i of log_lines.value) {
      if (i.match(num_reg)) {
        result.push(i.substring(6))
      } else {
        result.push(i)
      }
    }
    return result.join('\n')
  })

  const ws = ref(null)
  const running = ref(false)
  const waiting = ref(false)

  const get_task_id = ref(0)
  const task_list = ref([])

  const sc_uri = ref('')
  const basement_task_list = ref([])
  const speed_msg = ref([])
  async function get_running() {
    const { data } = await axios.get(`${import.meta.env.VITE_HTTP_URL}/scheduler`)
    running.value = !data.idle || data.next_time
  }

  async function get_tasks() {
    if (running.value) {
      const response = await axios.get(`${import.meta.env.VITE_HTTP_URL}/task`)
      task_list.value = response.data
      get_task_id.value = setTimeout(get_tasks, 3000)
    } else {
      task_list.value = []
    }
  }

  return {
    log,
    log_mobile,
    log_lines,
    ws,
    sc_uri,
    basement_task_list,
    running,
    waiting,
    speed_msg,
    get_running,
    task_list,
    get_task_id,
    get_tasks
  }
})
